function Editor()
{
	this.canvas;
	this.mode = "ground";
	
	this.type = "grass";
	this.types = ["grass", "water", "dirt", "dark", ];
	this.ground = {};
	this.grounds = [["grass", "water", "dirt", "dark"],
	                ["road1", "road1_tolower3", "road1_tolower1", "road1_tolower2", "road1_toupper2", "road1_toupper3", "road1_toupper1", "road"],
	                ["road2", "road2_tolower2", "road2_tolower3", "road2_tolower1", "road2_toupper3", "road2_toupper1", "road2_toupper2", ],
	                ["water_tl", "water_t", "water_tr",	"dirt_tl", "dirt_t", "dirt_tr",	"dark_br2", "dark_b", "dark_bl2"],
	                ["water_l", "water", "water_r",		"dirt_l", "dirt", "dirt_r",		"dark_r", "dark", "dark_l"],
	                ["water_bl", "water_b", "water_br",	"dirt_bl", "dirt_b", "dirt_br",	"dark_tr2", "dark_t", "dark_tl2"],
	                ["water_tl2", "water_tr2", "dirt_tl2", "dirt_tr2", "dark_br", "dark_bl"],
	                ["water_bl2", "water_br2", "dirt_bl2", "dirt_br2", "dark_tr", "dark_tl"]];
	this.objs = {};
	this.objTypes = ["rock", "oil", "tree", "barrel_blue", "barrel_red"];
	
	this.levelWidth = 5; this.levelHeight = 10;
	this.roadPathL = [0.5,0.5]; this.roadPathR = [9.5,9.5];
	this.next = [];
	
	//Init
	this.init = function()
	{
		this.canvas = $("#canvas");
		this.render();
		
		for(var key in this.types)
			$("#editor_type").append($("<option value='"+this.types[key]+"' />").text(this.types[key]));
		$("#editor_type").val(this.type);
	};
	
	//Render the Map
	this.render = function()
	{
		var tile, tileType, tileCord;
		
		this.canvas.html("");
		for(i=0, n=this.levelHeight; i<n; i++)
		{
			for(j=0, m=this.levelWidth; j<m; j++)
			{
				tileCord = j+"-"+i;
				tileType = this.type;
				if (this.ground[tileCord]) tileType = this.ground[tileCord];
				tileType = this.tileToSrc(tileType);
				
				tile = $("<div class='tile' data-cord='"+tileCord+"'><img src='media/tiles/"+tileType+".png' /></div>")
					.append("<span>"+tileCord+"</span>")
					.click(function()
					{
						Editor.tileChange($(this).attr("data-cord"));
					});
				
				this.canvas.append(tile);
			}
			this.canvas.append("<div style='display:block;'></div>");
		}
		
		
		//Add Road Path Lines
		this.canvas.find(".line").remove();
		function createLine(x1,y1, x2,y2){
		    var length = Math.sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
		  var angle  = Math.atan2(y2 - y1, x2 - x1) * 180 / Math.PI;
		  var transform = 'rotate('+angle+'deg)';

		    var line = $('<div>')
		        .appendTo('#canvas')
		        .addClass('line')
		        .css({
		          'position': 'absolute',
		          'transform': transform
		        })
		        .width(length)
		        .offset({left: x1, top: y1});
		    if (Editor.type == "dark") line.addClass("light");

		    return line;
		}
		createLine(0, this.roadPathL[0]*64, this.levelWidth*64, this.roadPathL[1]*64);
		createLine(0, this.roadPathR[0]*64, this.levelWidth*64, this.roadPathR[1]*64);
		
		//Objects
		var objectsDiv = $("#objects"), objIndex, div;
		objectsDiv.html(""); objIndex = 0;
		for(var objCord in this.objs)
		{
			div = $("<div class='object-line' data-index='"+objIndex+"' style='margin-bottom:3px;' />")
				.appendTo(objectsDiv)
				.append($("<input type='text' class='fl' style='width:75px;' />").val(objCord).change(function(){ Editor.objUpdate(this, "key"); }).click(function(){ Editor.objVisual(this); }))
				.append($("<div class='fl' style='width:15px;margin-left:5px;' />").html(":"))
				.append($("<input type='text' class='fl' style='width:150px;' />").val(this.objs[objCord]).change(function(){ Editor.objUpdate(this, "value"); }).click(function(){ Editor.objVisual(this); }))
				.append($("<a class='fl' style='margin-left:5px;' />").html("[x]").click(function(){ Editor.objRemove(this); }))
				.append($("<div class='clear'></div>"));
			
			objIndex++;
		}
		
		//Code needed
		var code = {id: "", type: this.type, w: this.levelWidth, ground: this.ground,
				roadPathL: this.roadPathL, roadPathR: this.roadPathR, objs: this.objs, next: this.next};
		$("#editor_code").val(JSON.stringify(code));
	};
	
	this.tileChangeCord = null;
	this.tileChange = function(tileCord)
	{
		this.tileChangeCord = tileCord;
		var tile = $("#canvas .tile[data-cord='"+this.tileChangeCord+"']");
		var left = tile.offset().left, top = tile.offset().top;
		
		var popupFull = $("<div class='popupfull' />");
		popupFull.click(function(){ $(".popupfull,.popupinner").remove(); });
		$("body").append(popupFull);
		var popup = $("<div class='popupinner'></div>");
		$("body").append(popup);
		
		if (left+popup.width() > $(window).width()) left = $(window).width() - popup.width();
		if (top+popup.height() > $(window).height()) top = $(window).height() - popup.height();
		
		popup.css({
			marginLeft: "0px",
			marginTop: "0px",
			left: left+"px",
			top: top+"px"
		});
		
		var tile, tiles = [], tileType;
		switch(this.mode)
		{
		default:
		case "ground":
			tiles = this.grounds;
		break;
		}
		for(var group in tiles)
		{
			for(var key in tiles[group])
			{
				tileType = tiles[group][key];
				tile = $("<div class='tile' data-type='"+tileType+"'><img src='media/tiles/"+this.tileToSrc(tileType)+".png' /></div>")
					//.append("<span>"+tileType+"</span>")
					.click(function()
					{
						Editor.tileChange2($(this).attr("data-type"));
					});
				popup.append(tile);
			}
			popup.append("<div></div>");
		}
	};
	this.tileChange2 = function(tileType)
	{
		$(".popupfull,.popupinner").remove();
		
		if (tileType != this.type) this.ground[this.tileChangeCord] = tileType;
		else delete this.ground[this.tileChangeCord];
		
		this.render();
	};
	
	//Change the type and update the map
	this.changeType = function(type)
	{
		this.type = type;
		for(var cord in this.ground)
			if (this.ground[cord] == type)
				delete this.ground[cord];
		this.render();
	};
	
	//Change the width and update the map
	this.changeWidth = function(width)
	{
		var cord2;
		this.levelWidth = width;
		for(var cord in this.ground)
		{
			cord2 = cord.split("-");
			if (parseInt(cord2[0]) >= width)
				delete this.ground[cord];
		}
		this.render();
	};
	
	//Change the Road Path Cords
	this.changeRoadPath = function(type, num, value)
	{
		value = parseFloat(value);
		switch(type.toLowerCase())
		{
		case "l": this.roadPathL[num] = value; break;
		case "r": this.roadPathR[num] = value; break;
		}
		this.render();
	};
	
	//Object - Add New
	this.objAdd = function()
	{
		this.objs[""] = "";
		
		this.render();
	};
	
	//Update Object Values
	this.objUpdate = function(objInput, type)
	{
		var objIndex = parseInt($(objInput).closest(".object-line").attr("data-index"));
		var objIndex2 = 0;
		
		var objs = {}, objValue;
		for(var objCord in this.objs)
		{
			objValue = this.objs[objCord];
			if (objIndex == objIndex2)
			{
				switch(type.toLowerCase())
				{
				case "key": objCord = $(objInput).val(); break;
				case "value": objValue = $(objInput).val(); break;
				}
				if (type.toLowerCase() != "delete") objs[objCord] = objValue;
			} else {
				objs[objCord] = objValue;
			}
			objIndex2++;
		}
		this.objs = objs;
		
		this.render();
	};
	
	//Remove the Object
	this.objRemove = function(objInput)
	{
		this.objUpdate(objInput, "delete");
	};
	
	//Visualize the Object
	this.objVisual = function(objInput)
	{
		var objIndex = parseInt($(objInput).closest(".object-line").attr("data-index")), objIndex2 = 0;
		var objCords, objValue;
		$(".tile").removeClass("object");
		
		for(var objCord in this.objs)
		{
			objValue = this.objs[objCord];
			if (objIndex == objIndex2)
			{
				//<div class="tile" data-cord="4-3"><img src="media/tiles/dirt.png"><span>4-3</span></div>
				objCords = objCord.split("|");
				for(var key in objCords)
					$(".tile[data-cord='"+objCords[key]+"']").addClass("object");
			}
			objIndex2++;
		}
	};
	
	
	//Sync Code and update the map
	this.syncCode = function(code)
	{
		code = JSON.parse(code);
		
		this.type = code.type;
		this.levelWidth = code.w;
		this.ground = code.ground;
		this.roadPathL = code.roadPathL; this.roadPathR = code.roadPathR;
		this.objs = code.objs;
		this.next = code.next;
		
		$("#editor_type").val(this.type);
		$("#editor_width").val(this.levelWidth);
		$("#roadPathL0").val(this.roadPathL[0]); $("#roadPathL1").val(this.roadPathL[1]);
		$("#roadPathR0").val(this.roadPathR[0]); $("#roadPathR1").val(this.roadPathR[1]);
		
		this.render();
	};
	
	this.tileToSrc = function(type)
	{
		if (type == "road") type = "road_asphalt22";
		else if (type == "road1") type = "road_asphalt04";
		else if (type == "road2") type = "road_asphalt40";
		else if (type == "road1_tolower1") type = "road_asphalt17";
		else if (type == "road1_tolower2") type = "road_asphalt18";
		else if (type == "road1_tolower3") type = "road_asphalt36";
		else if (type == "road2_tolower1") type = "road_asphalt35";
		else if (type == "road2_tolower2") type = "road_asphalt53";
		else if (type == "road2_tolower3") type = "road_asphalt54";
		else if (type == "road1_toupper1") type = "road_asphalt33";
		else if (type == "road1_toupper2") type = "road_asphalt15";
		else if (type == "road1_toupper3") type = "road_asphalt16";
		else if (type == "road2_toupper1") type = "road_asphalt51";
		else if (type == "road2_toupper2") type = "road_asphalt52";
		else if (type == "road2_toupper3") type = "road_asphalt34";
		/*else if (type == "water_t") type = "land_water09";
		else if (type == "water_tr") type = "land_water02";
		else if (type == "water_r") type = "land_water03";
		else if (type == "water_br") type = "land_water07";
		else if (type == "water_b") type = "land_water13";
		else if (type == "water_bl") type = "land_water06";
		else if (type == "water_l") type = "land_water05";
		else if (type == "water_tl") type = "land_water01";*/
		else if (type == "rock") rock = "rock1";
		else if (type == "tree") rock = "tree_small";
		
		return type;
	};
};
var Editor = new Editor();