function Game()
{
	this.canvas; this.context;
	this.renderWidth = 1280; this.renderHeight = 720;
	this.renderWidth = 1920; this.renderHeight = 1080;
	this.scale = 1280 / 1920;
	this.tileSize = 128; this.levelWidth = 5; this.levelHeight = 10;
	this.yOffset = -100;
	
	this.fuel = 0; this.fuelMax = 100;
	this.score = 0; this.distance = 0;
	
	this.gameStarted = false; this.isPaused = false; this.gameOver = false;
	this.gameOverTriggered = false;
	
	this.speedStartUp = true; this.speedStartUpInc = 0.15; this.speedStartUpFinal = 10;
	this.speed = 10; this.isOnRoad = true; this.isOnDirt = false;
	this.speedUpTTL = 0; this.speedUpData = {v:0, vMax:5, inc:0.1, incPercent: [1]};
	this.speedDown = 1; this.slowDownManual = false;
	
	this.carSelected = {type: "car", color: "blue"};
	this.car = {x: 200, y: 500, x2: 0, y2: 0, w: 70, h: 131, img: "car_red", color: "red", type: "playerCar"};
	this.carTracks = []; this.carUpgrade = ""; this.carUpgrade2 = "";
	this.rivals = []; this.rivalLastSpawn = 0;
	this.levels = []; this.rockets = [];
	this.explosions = [];
	this.canSwitchWorlds = false; this.canSwitchWorldsTTL = 10; this.canSwitchWorldsTTL0 = 10;
	
	this.minDistance_fireRockets = 250;
	
	this.cars = {};
	this.cars.car = {title: "Hot Rod",
		x: 0, y: 0, x2: 0, y2: 0, w: 70, h: 131, speed: 10, unlocked: true, fuel: 100,
		offroad: 1, offroad2: 1, honk: true,
		rocket: {canfire: true, dir: [0], firerate: 15, cooldown: 0, hits: 1},
		img: "car_", imgW: 70, imgH: 131, color: "red", type: "playerCar", hasColors: true};
	this.cars.bike = {title: "Bike",
		x: 0, y: 0, x2: 0, y2: 0, w: 36, h: 90, speed: 15, unlocked: false, fuel: 150,
		offroad: 0.8, offroad2: 0.5, honk: true,
		rocket: {canfire: false, dir: [0], firerate: 15, cooldown: 0, hits: 1},
		img: "bike_", imgW: 44, imgH: 100, color: "red", type: "playerCar", hasColors: true};
	this.cars.policecar = {title: "Police Car",
		x: 0, y: 0, x2: 0, y2: 0, w: 66, h: 128, speed: 12.5, unlocked: false, fuel: 200,
		offroad: 1.1, offroad2: 1.1, honk: false,
		rocket: {canfire: true, dir: [0], firerate: 10, cooldown: 0, hits: 1},
		img: "policecar1", imgW: 100, imgH: 150, color: "blue", type: "playerCar", hasColors: false,
		special: {
			active: false, data: {speed: 0},
			ttl: 0, ttl0: 20, speedMax: 5,
			render: function(car)
			{
				if (this.active)
				{
					this.ttl--;
					if (this.ttl <= 0)
					{
						this.ttl = this.ttl0;
						if (car.img == "policecar1") car.img = "policecar2";
						else car.img = "policecar1";
					}
					if (this.data.speed < this.speedMax)
						this.data.speed += 0.025;
				} else {
					if (this.data.speed > 0)
						this.data.speed -= 0.025;
				}
			},
			modeChange: function(car)
			{
				this.ttl = 0;
				
				if (this.active) Render.audio["sirens"].play();
				else Render.audio["sirens"].pause();
			}
		}};
	this.cars.ZaciCar = {title: "ZaciCar",
		x: 0, y: 0, x2: 0, y2: 0, w: 100, h: 100, speed: 7.5, unlocked: false, fuel: 75,
		offroad: 1.25, offroad2: 1.25, honk: true,
		rocket: {canfire: true, dir: [0, -45, 45, -180], firerate: 50, cooldown: 0, hits: 1},
		img: "ZaciCar", imgW: 200, imgH: 200, color: ["black", "blue", "green", "red", "yellow", "silver"], type: "playerCar", hasColors: false};
	
	this.upgrades = {};
	this.upgrades.fueladd = {type: "fuel", title: "Fuel Enhance", subtitle: "+25 Fuel Points",
		data: {car: {fuel: 25}}, img: "objects/barrel_blue"};
	this.upgrades.fueladd2 = {type: "fuel", title: "Fuel Enhance Max", subtitle: "+50 Fuel Points",
		data: {car: {fuel: 50}}, img: "objects/barrel_blue"};
	this.upgrades.speedadd = {type: "speed", title: "Speed Ultra", subtitle: "Increased Speed",
		data: {car: {speed: 2.5}}, img: "etc/road_arrow_right"};
	this.upgrades.speedadd2 = {type: "speed", title: "Speed Extreme", subtitle: "Increased Speed MAX",
		data: {car: {speed: 5}}, img: "etc/road_arrow_right"};
	this.upgrades.rocketfirerate = {type: "rocket", title: "Faster Fire Rate", subtitle: "25% Faster",
		data: {rocket: {firerate: 0.75}}, dataType: "percent", img: "etc/bulletRed_outline"};
	this.upgrades.rockethits = {type: "rocket", title: "Enhanced Rockets", subtitle: "+1 Rocket Power",
		data: {rocket: {hits: 1}}, img: "etc/bulletRed_outline"};
	this.upgrades.multirockets = {type: "rocket", title: "Multi Rockets", subtitle: "Extra Rockets",
		data: {rocket: {dir: [-20, 20]}}, dataType: "array_add", img: "etc/bulletRed_outline"};
	
	
	//Init
	this.init = function()
	{
		$("#mainmenu_game,#mainmenu_gamecolor,#mainmenu_gameupgrades,.controlsdivs").hide();
		
		var cxt = this.context;
		cxt.imageSmoothingEnabled = false;
		cxt.font = "14px KenVector Future"; cxt.lineWidth = 10;
		cxt.textBaseline = "top"; cxt.fillStyle = "#FFF";
		
		this.score = 0; this.distance = 0;
		this.gameStarted = true; this.isPaused = false; this.gameOver = false;
		this.gameOverTriggered = false;
		this.speedStartUp = true; this.speed = 0.1;
		this.speedUpTTL = 0; this.speedUpData.v = 0; this.speedUpData.incPercent = [1];
		this.speedDown = 1; this.slowDownManual = false;
		
		//Car Select
		this.car = jQuery.extend(true, {}, this.cars[this.carSelected.type]);
		this.car.x = 350; this.car.y = this.renderHeight/2;
		this.car.x2 = this.car.x; this.car.y2 = this.car.y;
		if (this.car.hasColors)
		{
			this.car.color = this.carSelected.color;
			this.car.img += this.carSelected.color;
		}
		this.isOnRoad = true; this.isOnDirt = false;
		this.carTracks.length = 0;
		
		//Upgrade Select
		var upgrades = [this.carUpgrade, this.carUpgrade2];
		var upgradeType, upgradeObj;
		for(var key in upgrades)
		{
			upgradeType = upgrades[key];
			if (!upgradeType) continue;
			upgradeObj = Game.upgrades[upgradeType];
			
			switch(upgradeObj.dataType)
			{
			default:
				if (upgradeObj.data.car)
					for(var fieldKey in upgradeObj.data.car)
						this.car[fieldKey] += upgradeObj.data.car[fieldKey];
				if (upgradeObj.data.rocket)
					for(var fieldKey in upgradeObj.data.rocket)
						this.car.rocket[fieldKey] += upgradeObj.data.rocket[fieldKey];
			break;
			
			case "percent":
				if (upgradeObj.data.car)
					for(var fieldKey in upgradeObj.data.car)
						this.car[fieldKey] *= upgradeObj.data.car[fieldKey];
				if (upgradeObj.data.rocket)
					for(var fieldKey in upgradeObj.data.rocket)
						this.car.rocket[fieldKey] *= upgradeObj.data.rocket[fieldKey];
			break;
			
			case "array_add":
				if (upgradeObj.data.car)
					for(var fieldKey in upgradeObj.data.car)
						for(var key in upgradeObj.data.car[fieldKey])
							this.car[fieldKey][this.car[fieldKey].length] = upgradeObj.data.car[fieldKey][key];
				if (upgradeObj.data.rocket)
					for(var fieldKey in upgradeObj.data.rocket)
						for(var key in upgradeObj.data.rocket[fieldKey])
							this.car.rocket[fieldKey][this.car.rocket[fieldKey].length] = upgradeObj.data.rocket[fieldKey][key];
			break;
			}
		}
		
		this.speedStartUpFinal = this.car.speed;
		this.fuelMax = this.car.fuel;
		this.fuel = this.fuelMax;
		
		//Reset
		this.speedUpTTL = 0;
		this.speedUpData.v = 0;
		
		this.rivals.length = 0;
		this.rockets.length = 0;
		this.explosions.length = 0;
		
		this.canSwitchWorlds = false;
		this.canSwitchWorldsTTL = this.canSwitchWorldsTTL0;
		
		this.levels.length = 0;
		this.determineNextLevel("start");
		this.determineNextLevel("a");
		//this.determineNextLevel("highwayDirtStart");
		
		Render.audioStopAll();
		Game.playBGMusic();
		
		Render.renderHandle = function(renderSpeed){ Game.render(renderSpeed); };
	};
	
	//Exit Game and return to Main Menu
	this.exit = function()
	{
		this.gameStarted = false;
		$("#pausemenu").hide();
		MainMenu.init();
		Render.renderHandle = null;
	};
	
	//Render
	this.render = function(renderSpeed)
	{
		this.gameAction(renderSpeed);
		
		//this.canvas.width = this.canvas.width+0;
		var cxt = this.context;
		var scale = this.scale;
		cxt.setTransform(1, 0, 0, 1, 0, 0);
		cxt.font = "14px KenVector Future"; cxt.lineWidth = 10;
		cxt.textBaseline = "top"; cxt.fillStyle = "#FFF";
		
		//Loop through levels
		var levels = this.levels, level, x, y, i, j, n, m, img, obj;
		//this.tileSize = 128; this.levelWidth = 5; this.levelHeight = 6;
		for(var levelID in levels)
		{
			level = levels[levelID];
			if (level.x >= this.renderWidth) continue;
			
			if (level.canvas) cxt.drawImage(level.canvas, level.x*scale, this.yOffset*scale);
		}
		
		
		//Skidmark
		var skid = Render.images["etc_skidmark"];
		var carTracks = this.carTracks, carTrack, carTrackLast = null;
		for(var key in carTracks)
		{
			carTrack = carTracks[key];
			if (carTrack.x+carTrack.w < 0) continue;
			
			angle = 90;
			if (carTrackLast)
			{
				angle = Render.determineAngle(carTrackLast.x, carTrackLast.y, carTrack.x, carTrack.y)-90;
				if (angle) angle += 90;
				else angle = 90;
			}
			
			var rotation_rads = degs_to_rads(angle), angle_sine = Math.sin(rotation_rads), angle_cosine = Math.cos(rotation_rads);
			cxt.setTransform(angle_cosine, angle_sine, -angle_sine, angle_cosine,
				carTrack.x*scale, carTrack.y*scale-skid.width*scale/2);
			cxt.drawImage(skid, 0, -skid.width*scale/2, skid.width*scale, carTrack.w);
			
			carTrackLast = carTrack;
		}
		
		//Rivals
		var rivals = this.rivals, rival, angle;
		for(var key in rivals)
		{
			rival = rivals[key];
			if (rival.destroyed) continue;
			
			angle = rival.a;
			if (rival.dir == -1) angle += 180;
			
			var rotation_rads = degs_to_rads(angle), angle_sine = Math.sin(rotation_rads), angle_cosine = Math.cos(rotation_rads);
			cxt.setTransform(angle_cosine, angle_sine, -angle_sine, angle_cosine,
				rival.x*scale, rival.y*scale);
			cxt.drawImage(Render.images[rival.img], -rival.w*scale/2, -rival.h*scale/2, rival.w*scale, rival.h*scale);
		}
		
		//Rockets
		var rockets = this.rockets, rocket;
		for(var key in rockets)
		{
			rocket = rockets[key];
			if (rocket.destroyed) continue;
			rocketImg = Render.images["etc_rocket_"+rocket.color];
			
			angle = 90+(rocket.a ? rocket.a : 0);
			
			var rotation_rads = degs_to_rads(angle), angle_sine = Math.sin(rotation_rads), angle_cosine = Math.cos(rotation_rads);
			cxt.setTransform(angle_cosine, angle_sine, -angle_sine, angle_cosine,
				rocket.x*scale, rocket.y*scale);
			cxt.drawImage(rocketImg, -rocketImg.width*scale/2, -rocketImg.height*scale/2, rocketImg.width*scale, rocketImg.height*scale);
		}
		
		//Player Car
		var car = this.car;
		angle = Render.determineAngle(car.x-10, car.y2, car.x, car.y);
		
		var rotation_rads = degs_to_rads(angle), angle_sine = Math.sin(rotation_rads), angle_cosine = Math.cos(rotation_rads);
		cxt.setTransform(angle_cosine, angle_sine, -angle_sine, angle_cosine,
			car.x*scale, car.y*scale);
		cxt.drawImage(Render.images[car.img], -car.imgW*scale/2, -car.imgH*scale/2, car.imgW*scale, car.imgH*scale);
		cxt.setTransform(1, 0, 0, 1, 0, 0);
		
		
		//Explosions
		var explosions = this.explosions, explode, reSave = false, img;
		for(var key in explosions)
		{
			explode = explosions[key];
			
			img = Render.images["etc_explode_"+explode.on];
			cxt.drawImage(img, (explode.x-img.width/2)*scale, (explode.y-img.height/2)*scale, img.width*scale, img.height*scale);
			
			explode.ttl--;
			if (explode.ttl <= 0)
			{
				explode.on++;
				explode.ttl = explode.ttl0;
				if (explode.on > 8) reSave = true;
			}
		}
		if (reSave)
		{
			var explosions2 = [];
			for(var key in explosions) if (explosions[key].on <= 8) explosions2[explosions2.length] = explosions[key];
			this.explosions = explosions2;
		}
		
		
		//Text
		cxt.lineWidth = 3;
		cxt.font = "bold 52px KenVector Future";
		cxt.textAlign = "right"; cxt.textBaseline = "top";
		cxt.fillStyle = "#FFF"; cxt.strokeStyle = "#000";
		cxt.strokeText(this.distance.toFixed(0), this.renderWidth*scale-5, 5);
		cxt.fillText(this.distance.toFixed(0), this.renderWidth*scale-5, 5);
		
		//Speed Meter
		var r = 60, x = this.renderWidth*scale/2, y = r+10;
		var bg1 = Render.images["etc_meter_bg1"], bg2 = Render.images["etc_meter_bg2"];
		var h = r, w = (bg1.width*h)/bg1.height;
		var needle = this.getSpeed().toFixed(2);
		//var needlePos = Render.determineNewPoints(x, y, r, -90+180*(needle / 30));
		var needleAngle = (-90+180*(needle / 30));
		if (needleAngle > 90) needleAngle = 90;
		needleAngle *= Math.PI/180;
		
		cxt.save();
		cxt.globalAlpha = 0.75;
		cxt.translate(x, y);
		cxt.drawImage(bg1, -w/2, -h, w, h);
		cxt.drawImage(bg2, -w/2, -h, w, h);
		cxt.globalAlpha = 1;
		cxt.rotate(needleAngle);
		cxt.drawImage(Render.images["etc_meter"], -w/2, -h, w, h);
		cxt.restore();
		
		
		//Visuals
		cxt.drawImage(Render.images["obj_barrel_blue"], 5, 5, 35, 35);
		
		var x = 45, w = this.fuelMax*2*scale - (Render.images["ui_barLeft_shadow"].width+Render.images["ui_barRight_shadow"].width);
		cxt.drawImage(Render.images["ui_barLeft_shadow"], x, 10); x += Render.images["ui_barLeft_shadow"].width;
		cxt.drawImage(Render.images["ui_barMiddle_shadow"], x, 10, w, Render.images["ui_barMiddle_shadow"].height); x += w;
		cxt.drawImage(Render.images["ui_barRight_shadow"], x, 10); x += Render.images["ui_barRight_shadow"].width;
		
		var w2 = this.fuel*2*scale, sideW = Render.images["ui_barLeft_shadow"].width; x = 45;
		//cxt.save(); cxt.rect(x, 10, this.fuel*2*scale, Render.images["ui_barMiddle_shadow"].height); cxt.clip();
		if (w2 > x-45+sideW)
			cxt.drawImage(Render.images["ui_barLeft_blue"], x, 10);
		else if (w2 >= x-45)
			cxt.drawImage(Render.images["ui_barLeft_blue"], 0, 0, w2, Render.images["ui_barLeft_blue"].height, x, 10, w2-(x-45), Render.images["ui_barLeft_blue"].height);
		x += sideW;
		if (w2 > x-45)
			cxt.drawImage(Render.images["ui_barMiddle_blue"], x, 10, Math.min(w2-sideW, w), Render.images["ui_barMiddle_shadow"].height);
		x += w;
		if (w2 >= x-45)
			cxt.drawImage(Render.images["ui_barRight_blue"], 0, 0, w2-(x-45), Render.images["ui_barRight_blue"].height, x, 10, w2-(x-45), Render.images["ui_barRight_blue"].height);
		//x += sideW;
		//cxt.restore();
	};
	
	//Game Action
	this.gameAction = function(renderSpeed)
	{
		if (this.gameOver && !this.gameOverTriggered) this.gameOverAction();
		if (this.gameOver || this.isPaused) return true;
		var car = this.car;
		var speed = this.getSpeed()*renderSpeed, now = Date.now();
		if (speed == 0) this.gameOver = true;
		
		//Car Special
		if (car.special && car.special.render) car.special.render(car);
		
		//Play Low Fuel Music
		if (this.fuel/this.fuelMax < 0.2)
		{
			if (Render.audio["lowGas"].paused) Render.audio["lowGas"].play();
		} else {
			if (!Render.audio["lowGas"].paused) Render.audio["lowGas"].pause();
		}
		
		//Car Speed Actions
		if (this.speedUpTTL)
		{
			this.speedUpTTL--;
			this.speedUpData.v += this.speedUpData.inc*this.speedUpData.incPercent[0];
			if (this.speedUpData.v > this.speedUpData.vMax) this.speedUpData.v = this.speedUpData.vMax;
			if (this.speedUpData.incPercent.length > 1) this.speedUpData.incPercent.shift();
		} else if (this.speedUpData.v > 0) {
			this.speedUpData.v -= this.speedUpData.inc;
			if (this.speedUpData.v < 0) this.speedUpData.v = 0;
			this.speedUpData.incPercent = [1];
		}
		if (this.isOnRoad && this.speedDown < 1)
		{
			if (this.slowDownManual) this.speedDownPlayerCar(0.75);
			else this.speedDownPlayerCar(-1);
		} else if (!this.isOnRoad) {
			this.speedDownPlayerCar(this.isOnDirt ? 1.25 : 1);
		} else {
			if (this.slowDownManual) this.speedDownPlayerCar(0.75);
		}
		if (car.rocket.canfire && car.rocket.cooldown > 0) car.rocket.cooldown -= renderSpeed;
		
		
		
		/*---    Movement/Actions    ---*/
		
		//Player Car Move
		if (this.fuel > 0) this.eventTrigger("held", {});
		this.carTracks[this.carTracks.length] = {x: this.car.x, y: this.car.y, w: speed};
		this.fuel -= 0.05;
		if (this.fuel < 0) this.fuel = 0;
		this.distance += speed/128;
		
		//Rockets
		var rockets = this.rockets, rocket, moveAmt;
		for(var key in rockets)
		{
			rocket = rockets[key];
			
			if (rocket.aOffset == 0)
			{
				rocket.x += (rocket.a <= 90 ? speed : -speed)+rocket.speed;
				if ((rocket.a >= 0 ? rocket.a : -rocket.a) % 90 > 2) rocket.y += (rocket.a>0?1:-1)*rocket.speedY*1.25;
			} else {
				var newPos = Render.determineNewPoints(rocket.x, rocket.y, (rocket.a <= 90 ? speed : -speed)+rocket.speed, rocket.a+90);
				rocket.x = newPos.x; rocket.y = newPos.y;
			}
		}
		
		//Levels
		var doSaveLevels = false;
		var levels = this.levels, level, lastX = 0;
		for(var levelID in levels)
		{
			level = levels[levelID];
			
			level.x -= speed;
			if (lastX < level.x+level.w*this.tileSize) lastX = level.x+level.w*this.tileSize;
			
			if (level.x + level.w*this.tileSize < 0) doSaveLevels = true;
		}
		
		//Car Tracks
		var carTracks = this.carTracks, carTrack;
		for(var key in carTracks) carTracks[key].x -= speed;
		
		//Rivals
		var rivals = this.rivals, rival, rivalLevel, roadPath;
		for(var key in rivals)
		{
			rival = rivals[key];

			rival.x2 = rival.x; rival.y2 = rival.y;
			rival.x -= speed+rival.speed;
			
			rivalLevel = null;
			for(var key in levels)
			{
				if (rivalLevel) continue;
				level = levels[key];
				if (level.x <= rival.x && rival.x <= level.x+level.w*this.tileSize) rivalLevel = level;
			}
			if (!rivalLevel) continue;
			
			roadPath = rival.dir == -1 ? rivalLevel.roadPathL : rivalLevel.roadPathR;
			if (roadPath[0] == roadPath[1])
			{
				rival.y = roadPath[0]*this.tileSize+this.yOffset;
				rival.a = 90;
			} else {
				var spot = Render.doesInterceptLine(rival.x, 0, rival.x, this.renderHeight,
					rivalLevel.x, roadPath[0]*this.tileSize+this.yOffset, rivalLevel.x+rivalLevel.w*this.tileSize, roadPath[1]*this.tileSize+this.yOffset);
				if (spot)
					rival.y = spot.y;
				rival.a = Render.determineAngle(rivalLevel.x, roadPath[0]*this.tileSize+this.yOffset,
						rivalLevel.x+rivalLevel.w*this.tileSize, roadPath[1]*this.tileSize+this.yOffset);
			}
		}
		
		//Explosions
		var explosions = this.explosions, explode;
		for(var key in explosions)
		{
			explode = explosions[key];
			
			explode.x -= speed;
		}
		
		
		/*---    Collision Detection    ---*/
		var hit, poly, objs, objCord, objType, obj, objReSave, img;
		
		//Rocket Hits
		for(var key in rockets)
		{
			rocket = rockets[key];
			if (rocket.destroyed) continue;
			
			//Hit a Rival
			if (rocket.type == "playerCar")
			{
				for(var key in rivals)
				{
					rival = rivals[key];
					if (rocket.destroyed || rival.destroyed) continue;
					
					poly = [];
					poly[poly.length] = {x: rival.x-rival.w/2, y: rival.y-rival.h/2};
					poly[poly.length] = {x: rival.x+rival.w/2, y: rival.y-rival.h/2};
					poly[poly.length] = {x: rival.x+rival.w/2, y: rival.y+rival.h/2};
					poly[poly.length] = {x: rival.x-rival.w/2, y: rival.y+rival.h/2};
					if (Render.pointInPolygon(rocket.x, rocket.y, poly))
					{
						doSaveLevels = true;
						rocket.destroyed = true;
						this.destroyRival(rival);
						this.addScore(2);
						this.speedUpPlayerCar();
					}
				}
			}
			
			//Hit the Player Car
			if (rocket.type == "rival")
			{
				rival = this.car;
				if (rocket.destroyed || rival.destroyed) continue;
				
				poly = [];
				poly[poly.length] = {x: rival.x-rival.w/2, y: rival.y-rival.h/2};
				poly[poly.length] = {x: rival.x+rival.w/2, y: rival.y-rival.h/2};
				poly[poly.length] = {x: rival.x+rival.w/2, y: rival.y+rival.h/2};
				poly[poly.length] = {x: rival.x-rival.w/2, y: rival.y+rival.h/2};
				if (Render.pointInPolygon(rocket.x, rocket.y, poly))
				{
					doSaveLevels = true;
					rocket.destroyed = true;
					this.addExplosion(car.x, car.y);
					this.gameOver = true;
				}
			}
			
			//Hit another Rocket
			for(var key in rockets)
			{
				var rocket2 = rockets[key];
				if (rocket.destroyed || rocket2.destroyed || rocket === rocket2 || rocket.type == rocket2.type) continue;
				
				poly = [];
				poly[poly.length] = {x: rocket2.x-rocket2.w, y: rocket2.y-rocket2.h};
				poly[poly.length] = {x: rocket2.x+rocket2.w, y: rocket2.y-rocket2.h};
				poly[poly.length] = {x: rocket2.x+rocket2.w, y: rocket2.y+rocket2.h};
				poly[poly.length] = {x: rocket2.x-rocket2.w, y: rocket2.y+rocket2.h};
				if (Render.pointInPolygon(rocket.x, rocket.y, poly))
				{
					doSaveLevels = true;
					rocket.destroyed = true;
					rocket2.destroyed = true;
					this.addExplosion(rocket.x, rocket.y);
				}
			}
			
			//Hit an Obstacle
			for(var levelID in levels)
			{
				level = levels[levelID];
				if (!level.objs || rocket.destroyed) continue;
				if (!(level.x <= rocket.x && rocket.x <= level.x+level.w*this.tileSize)) continue;
				
				objs = level.objs; objReSave = false;
				for(objCord in objs)
				{
					objType = objs[objCord].type;
					if (objType.match(/coin|oil/i)) continue;
					img = Render.images["obj_"+objType];
					objCord = objCord.split("-");
					obj = {x: level.x+parseInt(objCord[0])*this.tileSize, y: this.yOffset+parseInt(objCord[1])*this.tileSize, w: img.width, h: img.height};
					obj.x += this.tileSize/2; obj.y += this.tileSize/2;
					
					poly = [];
					poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y-obj.h/2};
					poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y-obj.h/2};
					poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y+obj.h/2};
					poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y+obj.h/2};
					hit = Render.pointInPolygon(rocket.x, rocket.y, poly);
					if (hit)
					{
						rocket.destroyed = true;
						
						if (objType.match(/barrel_red/i))
						{
							doSaveLevels = true;
							this.addExplosion(obj.x, obj.y);
							delete objs[objCord.join("-")];
							objReSave = true;
						} else if (objType.match(/barrel_blue/i)) {
							doSaveLevels = true;
							objs[objCord.join("-")] = {type: "oil", angle: 0};
							objReSave = true;
						} else if (objType == "rocketlauncher") {
							doSaveLevels = true;
							this.addExplosion(obj.x, obj.y);
							objs[objCord.join("-")].hp--;
							if (objs[objCord.join("-")].hp <= 0)
							{
								delete objs[objCord.join("-")];
								
								this.addScore(2);
								this.speedUpPlayerCar(1.25);
							}
							objReSave = true;
						} else {
							if (!objType.match(/oil/i))
							{
								rocket.hit = 0;
							}
						}
					}
				}
				if (objReSave)
				{
					objs = {};
					for(var key in level.objs) if (level.objs[key]) objs[key] = level.objs[key];
					level.objs = objs;
					
					this.generateLevelCache(level);
				}
			}
		}
		
		//Rival Hits
		for(var key in rivals)
		{
			rival = rivals[key];
			if (rival.destroyed) continue;
			
			//Negative X
			if (rival.x < 0)
			{
				rival.negTTL--;
				if (rival.negTTL <= 0) rival.destroyed = true;
			}
			
			//Hit another Rival
			for(var key in rivals)
			{
				rival2 = rivals[key];
				if (rival.destroyed || rival2.destroyed || rival == rival2) continue;
				
				poly = [];
				poly[poly.length] = {x: rival2.x-rival2.w/2, y: rival2.y-rival2.h/2};
				poly[poly.length] = {x: rival2.x+rival2.w/2, y: rival2.y-rival2.h/2};
				poly[poly.length] = {x: rival2.x+rival2.w/2, y: rival2.y+rival2.h/2};
				poly[poly.length] = {x: rival2.x-rival2.w/2, y: rival2.y+rival2.h/2};
				if (Render.pointInPolygon(rival.x, rival.y, poly))
				{
					doSaveLevels = true;
					this.destroyRival(rival);
					this.destroyRival(rival2);
				}
			}
			
			//Hit an Obstacle
			for(var levelID in levels)
			{
				level = levels[levelID];
				if (!level.objs || rival.destroyed) continue;
				if (!(level.x-100 <= rival.x && rival.x <= level.x+level.w*this.tileSize+100)) continue;
				
				objs = level.objs; objReSave = false;
				for(objCord in objs)
				{
					objType = objs[objCord].type;
					if (objType.match(/coin|oil/i)) continue;
					img = Render.images["obj_"+objType];
					objCord = objCord.split("-");
					obj = {x: level.x+parseInt(objCord[0])*this.tileSize, y: this.yOffset+parseInt(objCord[1])*this.tileSize, w: img.width, h: img.height};
					obj.x += this.tileSize/2; obj.y += this.tileSize/2;
					if (obj.x < 0 || obj.x > this.renderWidth*0.95) continue;
					
					poly = [];
					poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y-obj.h/2};
					poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y-obj.h/2};
					poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y+obj.h/2};
					poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y+obj.h/2};
					if (Render.pointInPolygon(rival.x, rival.y, poly)
						|| Render.pointInPolygon(rival.x-rival.w*0.4, rival.y-rival.h*0.4, poly)
						|| Render.pointInPolygon(rival.x+rival.w*0.4, rival.y-rival.h*0.4, poly)
						|| Render.pointInPolygon(rival.x+rival.w*0.4, rival.y+rival.h*0.4, poly)
						|| Render.pointInPolygon(rival.x-rival.w*0.4, rival.y+rival.h*0.4, poly))
					{
						if (objType.match(/barrel_red/i))
						{
							this.destroyRival(rival);
							doSaveLevels = true;
							this.addExplosion(obj.x, obj.y);
							delete objs[objCord.join("-")];
							objReSave = true;
						} else if (objType.match(/barrel_blue/i)) {
							doSaveLevels = true;
							objs[objCord.join("-")] = {type: "oil", angle: 0};
							objReSave = true;
						} else {
							this.destroyRival(rival);
							doSaveLevels = true;
							//this.addExplosion(obj.x, obj.y);
						}
					}
				}
				if (objReSave)
				{
					objs = {};
					for(var key in level.objs) if (level.objs[key]) objs[key] = level.objs[key];
					level.objs = objs;
					
					this.generateLevelCache(level);
				}
			}
		}
		
		//Player Detection
		this.isOnRoad = false; this.isOnDirt = false;
		for(var key in rivals)
		{
			rival = rivals[key];
			if (rival.destroyed) continue;
			
			poly = [];
			poly[poly.length] = {x: rival.x-rival.w/2, y: rival.y-rival.h/2};
			poly[poly.length] = {x: rival.x+rival.w/2, y: rival.y-rival.h/2};
			poly[poly.length] = {x: rival.x+rival.w/2, y: rival.y+rival.h/2};
			poly[poly.length] = {x: rival.x-rival.w/2, y: rival.y+rival.h/2};
			if (Render.pointInPolygon(car.x-car.w/2, car.y, poly) || Render.pointInPolygon(car.x+car.w/2, car.y, poly))
			{
				this.addExplosion(car.x, car.y);
				this.gameOver = true;
				this.destroyRival(rival);
			}
		}
		var myTile = "";
		for(var levelID in levels)
		{
			level = levels[levelID];
			if (!(level.x <= car.x && car.x < level.x+level.w*this.tileSize)) continue;
			
			//Ground Detection
			objs = level.ground;
			for(objCord in objs)
			{
				if (myTile) continue;
				objType = objs[objCord];
				img = Render.images[objType];
				objCord = objCord.split("-");
				obj = {x: level.x+parseInt(objCord[0])*this.tileSize, y: this.yOffset+parseInt(objCord[1])*this.tileSize, w: img.width, h: img.height};
				obj.x += this.tileSize/2; obj.y += this.tileSize/2;
				
				poly = [];
				poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y-obj.h/2};
				poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y-obj.h/2};
				poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y+obj.h/2};
				poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y+obj.h/2};
				hit = Render.pointInPolygon(car.x, car.y, poly);
				if (hit)
				{
					myTile = objType;
					if (myTile.match(/\_[tlbr2]{1,3}$/i))
					{
						var myTileAlt = level.type, myTileDir = 1;
						if (myTile.match(/dark/i))
						{
							//myTile = myTile.replace(/dark/i, 'dirt');
							myTileDir = -1;
						}
						if (myTile.match(/t(r|l)?$/i))
						{
							obj.h /= 2;
							obj.y += obj.h;
						} else if (myTile.match(/b(r|l)?$/i)) {
							obj.h /= 2;
							obj.y -= obj.h;
						}
						if (myTile.match(/l$/i))
						{
							obj.w /= 2;
							obj.x += obj.w;
						} else if (myTile.match(/r$/i)) {
							obj.w /= 2;
							obj.x -= obj.w;
						}

						poly = [];
						if (!myTile.match(/2$/i))
						{
							poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y-obj.h/2};
							poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y-obj.h/2};
							poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y+obj.h/2};
							poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y+obj.h/2};
						} else {
							if (myTile.match(/tl2/i))
							{
								poly[poly.length] = {x: obj.x, y: obj.y};
								poly[poly.length] = {x: obj.x, y: obj.y-obj.h/2};
								poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y-obj.h/2};
								poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y+obj.h/2};
								poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y+obj.h/2};
								poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y};
							} else if (myTile.match(/tr2/i)) {
								poly[poly.length] = {x: obj.x, y: obj.y};
								poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y};
								poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y+obj.h/2};
								poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y+obj.h/2};
								poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y-obj.h/2};
								poly[poly.length] = {x: obj.x, y: obj.y-obj.h/2};
							} else if (myTile.match(/br2/i)) {
								poly[poly.length] = {x: obj.x, y: obj.y};
								poly[poly.length] = {x: obj.x, y: obj.y+obj.h/2};
								poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y+obj.h/2};
								poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y-obj.h/2};
								poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y-obj.h/2};
								poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y};
							} else if (myTile.match(/bl2/i)) {
								poly[poly.length] = {x: obj.x, y: obj.y};
								poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y};
								poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y-obj.h/2};
								poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y-obj.h/2};
								poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y+obj.h/2};
								poly[poly.length] = {x: obj.x, y: obj.y-obj.h/2};
							}
						}
						hit = Render.pointInPolygon(car.x, car.y, poly);
						if (!hit) myTile = myTileAlt;
						else if (myTileDir == -1) myTile = myTile.replace(/dark/i, 'dirt');
					}
				}
			}
			if (myTile)
			{
				objType = myTile;
				if (objType.match(/^road/i))
				{
					this.isOnRoad = true;
					if (level.id.match(/^barrier/i) && !level.pointsAdded && 0)
					{
						this.addScore(1);
						level.pointsAdded = true;
					}
				} else if (objType.match(/^dirt/)) {
					this.isOnDirt = true;
				} else if (objType.match(/water|dark/i)) {
					this.gameOver = true;
				}
			} else {
				objType = level.type;
				if (objType.match(/^dirt/)) {
					this.isOnDirt = true;
				} else if (objType.match(/water|dark/i))
				{
					this.gameOver = true;
				}
			}
			
			//Hit an Obstacle
			objs = level.objs; objReSave = false;
			for(objCord in objs)
			{
				objType = objs[objCord].type;
				img = Render.images["obj_"+objType];
				objCord = objCord.split("-");
				obj = {x: level.x+parseInt(objCord[0])*this.tileSize, y: this.yOffset+parseInt(objCord[1])*this.tileSize, w: img.width, h: img.height};
				obj.x += this.tileSize/2; obj.y += this.tileSize/2;
				if (objType.match(/barrel_red|rock|tree/i))
				{
					obj.w *= 0.80;
					obj.h *= 0.80;
				}
				
				poly = [];
				poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y-obj.h/2};
				poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y-obj.h/2};
				poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y+obj.h/2};
				poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y+obj.h/2};
				if (Render.pointInPolygon(car.x, car.y, poly) || Render.pointInPolygon(car.x-car.h/2, car.y, poly)
					|| Render.pointInPolygon(car.x+car.h/2, car.y, poly) || Render.pointInPolygon(car.x, car.y-car.w/2, poly)
					|| Render.pointInPolygon(car.x, car.y+car.w/2, poly))
				{
					if (objType.match(/coin/i))
					{
						var amt = 1;
						if (objType.match(/silver/i)) amt = 2; else if (objType.match(/gold/i)) amt = 3;
						this.addScore(amt);
						
						delete objs[objCord.join("-")];
						objReSave = true;
					} else if (objType.match(/barrel_blue/i)) {
						this.fuel += 15;
						if (this.fuel > this.fuelMax) this.fuel = this.fuelMax;
						
						delete objs[objCord.join("-")];
						objReSave = true;
						this.speedUpPlayerCar(0.2);
						
						Render.audio["getItem"].play();
					} else if (objType.match(/oil/i)) {
						this.fuel += 0.5;
						if (this.fuel > this.fuelMax) this.fuel = this.fuelMax;
						
						Render.audio["oil"].play();
					} else {
						this.gameOver = true;
						this.addExplosion(car.x, car.y);
						
						if (objType.match(/barrel_red/i))
						{
							this.addExplosion(obj.x, obj.y);
							delete objs[objCord.join("-")];
							objReSave = true;
						}
					}
				}
			}
			if (objReSave)
			{
				objs = {};
				for(var key in level.objs) if (level.objs[key]) objs[key] = level.objs[key];
				level.objs = objs;
				
				this.generateLevelCache(level);
			}
			
			//Specials
			var specials = level.specials, special;
			for(objCord in specials)
			{
				special = specials[objCord];
				objCord = objCord.split("-");
				obj = {x: level.x+parseInt(objCord[0])*this.tileSize, y: this.yOffset+parseInt(objCord[1])*this.tileSize, w: img.width, h: img.height};
				obj.x += this.tileSize/2; obj.y += this.tileSize/2;
				
				poly = [];
				poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y-obj.h/2};
				poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y-obj.h/2};
				poly[poly.length] = {x: obj.x+obj.w/2, y: obj.y+obj.h/2};
				poly[poly.length] = {x: obj.x-obj.w/2, y: obj.y+obj.h/2};
				if (Render.pointInPolygon(car.x, car.y, poly) || Render.pointInPolygon(car.x-car.h/2, car.y, poly)
					|| Render.pointInPolygon(car.x+car.h/2, car.y, poly) || Render.pointInPolygon(car.x, car.y-car.w/2, poly)
					|| Render.pointInPolygon(car.x, car.y+car.w/2, poly))
				{
					if (special.match(/road_arrow_right/i))
					{
						this.speedUpPlayerCar(0.05, 0.5);
					} else if (special.match(/road_arrow_left/i))
					{
						this.speedUpPlayerCar(-0.05, 0.5);
					}
				}
			}
		}
		
		
		/*---    Clean Up    ---*/
		if (doSaveLevels)
		{
			var rockets2 = [];
			for(var key in rockets)
			{
				rocket = rockets[key];
				if (rocket.destroyed)
				{
					rocket.hits--;
					if (rocket.hits <= 0) continue;
					else rocket.destroyed = false;
				}
				if (rocket.x+rocket.w < 0 || rocket.x+rocket.w > this.renderWidth*1.25) continue;
				if (rocket.y+rocket.h < 0 || rocket.y+rocket.h > this.renderHeight) continue;
				
				rockets2[rockets2.length] = rocket;
			}
			this.rockets = rockets2;
			
			var levels2 = [];
			for(var levelID in levels)
			{
				level = levels[levelID];
				if (level.x + level.w*this.tileSize < 0) continue;
				
				levels2[levels2.length] = level;
			}
			this.levels = levels2;
			
			var carTracks2 = [];
			for(var key in carTracks)
			{
				carTrack = carTracks[key];
				if (carTrack.x+carTrack.w >= 0) carTracks2[carTracks2.length] = carTrack;
			}
			this.carTracks = carTracks2;
			
			var rivals2 = [];
			for(var key in rivals)
			{
				rival = rivals[key];
				if (rival.x+rival.w >= -300 && !rival.destroyed) rivals2[rivals2.length] = rival;
			}
			this.rivals = rivals2;
		}
		
		//Generate New Level
		if (lastX - this.renderWidth/2 < this.renderWidth)
		{
			this.determineNextLevel();
			
			//Spawn new Rivals
			if (Math.random() < 0.25+Math.max(this.distance/100, 0.5) &&
				now - this.rivalLastSpawn > 2500-Math.max(this.distance/10, 1000) &&
				this.rivals.length < 5 && this.distance > 25)
			{
				if (this.spawnRival()) this.rivalLastSpawn = now;
			}
		}
		
		//Spawn Rockets?
		if (this.distance > this.minDistance_fireRockets && Math.random() < 0.01)
		{
			var hasFired = false;
			var colors = ["black", "blue", "green", "red", "yellow"], color;
			color = colors[~~(Math.random()*colors.length)];
			var speed = -(Math.random()*7.5 + 5);
			
			var spots = [];
			var levels = this.levels, objs, obj, objCord2, x, y;
			for(var key in levels)
			{
				level = this.levels[key];
				if (level.x+level.w*this.tileSize < 350) continue;
				
				objs = level.objs;
				if (objs)
				{
					for(var objCord in objs)
					{
						obj = objs[objCord];
						if (obj.type != "rocketlauncher") continue;
						
						objCord2 = objCord.split("-");
						x = level.x+parseInt(objCord2[0])*this.tileSize-this.tileSize/4;
						y = parseInt(objCord2[1])*this.tileSize+this.tileSize/2+this.yOffset;
						
						spots[spots.length] = {x: x, y: y};
					}
				}
			}
			
			if (spots.length)
			{
				var spot = spots[Math.floor(Math.random()*spots.length)];
				
				this.fireRocket({
					x: spot.x, y: spot.y, img: this.car.img, color: color, type: "rival"},
					180, speed, 1.5);
			}
		}
		
		
		//Start Up?
		if (this.speedStartUp)
		{
			this.speed += this.speedStartUpInc;
			if (this.speed >= this.speedStartUpFinal)
			{
				this.speed = this.speedStartUpFinal;
				this.speedStartUp = false;
			}
		}
	};
	
	//Determine Next Level
	this.determineNextLevel = function(levelID)
	{
		var x = 0, newLevelIDs, oldLevelType = "", newLevelType = "", img;
		if (levelID == undefined)
		{
			if (this.levels.length == 0)
			{
				levelID = "a";
			} else {
				oldLevelType = this.levels[this.levels.length-1].type;
				levelID = this.levels[this.levels.length-1].next;
				if (!Array.isArray(levelID)) levelID = [levelID];
				
				if (levelID[0] != undefined)
				{
					newLevelIDs = levelID;
					do
					{
						levelID = newLevelIDs[~~(Math.random()*newLevelIDs.length)];
						newLevelType = __Levels[levelID].type;
					} while(newLevelIDs.length > 1
						&& ((!this.canSwitchWorlds && oldLevelType != newLevelType && !levelID.match(/^highway/i))
							|| (MainMenu.isOpen && oldLevelType != newLevelType)));
				} else levelID = undefined;
			}
		}
		if (this.levels.length > 0)
		{
			var level = this.levels[this.levels.length-1];
			if (level[0] != undefined)
			{
				this.levels[this.levels.length-1].pop();
				level = this.levels[this.levels.length-1];
			}
			x = level.x + level.w*this.tileSize;
		}
		if (levelID == undefined || !levelID) levelID = "start";
		
		var level = jQuery.extend(true, {}, __Levels[levelID]);
		level.x = x;
		
		if (!this.canSwitchWorlds)
		{
			this.canSwitchWorldsTTL--;
			if (this.canSwitchWorldsTTL <= 0)
			{
				this.canSwitchWorlds = true;
				this.canSwitchWorldsTTL = this.canSwitchWorldsTTL0;
			}
		} else if (oldLevelType != newLevelType) this.canSwitchWorlds = false;
		
		//Objects
		var objs = {}, obj, rand = 0.85, coins = ["bronze", "silver", "gold"],
			angles = [0, 90, 180, 270];
		if (level.objs)
		{
			for(var objCord in level.objs)
			{
				obj = level.objs[objCord].split("|");
				obj = obj[~~(Math.random()*obj.length)];
				objCord = objCord.split("|"); objCord = objCord[~~(Math.random()*objCord.length)];
				if (obj == "rock") obj = "rock"+~~(Math.random()*3+1);
				else if (obj == "coin") obj += "_"+coins[~~(Math.random()*coins.length)];
				//else if (obj == "barrier" || obj == "barrier_red") rand = 1;
				if (Math.random() < rand && obj) objs[objCord] = {type: obj, angle: angles[~~(Math.random()*angles.length)]};
			}
			level.objs = objs;
		}
		
		//Extra Objects - Rocket Launcher
		rand = 0.5;
		if (this.distance > this.minDistance_fireRockets)
		{
			var n = 1+Math.min(Math.floor(this.distance/500), 3);
			for(var i=0; i<n; i++)
			{
				objCord = Math.floor(Math.random()*level.w)+"-"+(1+Math.floor(Math.random()*(this.levelHeight-2)));
				if (objs[objCord] != undefined) continue;
				if (level.type.match(/dark|water/i) || (level.ground[objCord] && level.ground[objCord].match(/road|water|dark/i))) continue;
				
				if (Math.random() < rand && obj) objs[objCord] = {type: "rocketlauncher", hp: 2, angle: 0};
			}
			level.objs = objs;
		}
		
		//Make sure all objects are in range
		if (level.objs)
		{
			var objs = {};
			for(var objCord in level.objs)
			{
				objType = level.objs[objCord].type;
				img = Render.images["obj_"+objType];
				objCord = objCord.split("-");
				obj = {x: parseInt(objCord[0])*this.tileSize, y: this.yOffset+parseInt(objCord[1])*this.tileSize, w: img.width, h: img.height};
				obj.x += this.tileSize/2; obj.y += this.tileSize/2;
				objCord = objCord.join("-");
				
				if (obj.x+img.width < 0 || obj.x > level.w*this.tileSize) continue;
				objs[objCord] = level.objs[objCord];
			}
			level.objs = objs;
		}
		
		//Special - Overlays
		level.specials = {};
		if (this.distance >= 50)
		{
			for(var cord in level.ground)
			{
				img = level.ground[cord];
				if (!img.match(/^road[12]$/)) continue;
				if (Math.random() > (img == "road2" ? 0.05 : 0.025)) continue;
				
				level.specials[cord] = "road_arrow_"+(img == "road1" ? "left" : "right");
			}
		}
		
		//Cache the Level Graphics
		this.generateLevelCache(level);
		
		this.levels[this.levels.length] = level;
	};
	
	//Generare Level Cache
	this.generateLevelCache = function(level)
	{
		//Cache the ground texture
		var scale = this.scale;
		level.canvas = document.createElement("canvas");
		level.canvas.width = level.w*this.tileSize*scale; level.canvas.height = this.levelHeight*this.tileSize*scale;
		var cxt = level.canvas.getContext("2d");
		for(i=0, n=level.w; i<n; i++)
		{
			for(j=0, m=this.levelHeight; j<m; j++)
			{
				cxt.drawImage(Render.images[level.type], i*this.tileSize*scale, j*this.tileSize*scale, this.tileSize*scale, this.tileSize*scale);
				
				//Ground
				if (level.ground[i+"-"+j])
				{
					img = level.ground[i+"-"+j];
					cxt.drawImage(Render.images[img], i*this.tileSize*scale, j*this.tileSize*scale, this.tileSize*scale, this.tileSize*scale);
				}
				
				//Specials
				if (level.specials[i+"-"+j])
				{
					img = level.specials[i+"-"+j];
					cxt.drawImage(Render.images[img], i*this.tileSize*scale, j*this.tileSize*scale, this.tileSize*scale, this.tileSize*scale);
				}
			}
		}
		
		//Objects
		if (level.objs)
		{
			for(i=0, n=level.w; i<n; i++)
			{
				for(j=0, m=this.levelHeight; j<m; j++)
				{
					if (level.objs[i+"-"+j])
					{
						obj = level.objs[i+"-"+j];
						img = Render.images["obj_"+obj.type];
						
						cxt.save();
						cxt.translate((i*Game.tileSize+Game.tileSize*0.5)*scale, (j*Game.tileSize+Game.tileSize*0.5)*scale);
						cxt.rotate(obj.angle*(Math.PI/180));
						cxt.drawImage(img, (-img.width/2)*scale, (-img.height/2)*scale, img.width*scale, img.height*scale);
						cxt.restore();
					}
				}
			}
		}
	};
	
	//Get Player Speed
	this.getSpeed = function()
	{
		if (this.fuel <= 0) return 0;
		var speed = this.speed+this.speedUpData.v+Math.min(5, this.distance/150);
		if (this.car.special && this.car.special.data.speed) speed += this.car.special.data.speed;
		speed *= this.speedDown;
		
		return (speed > 0 ? speed : 0);
	};
	
	//Speed up Player Car
	this.speedUpPlayerCar = function(percent, incPercent)
	{
		if (percent == undefined) percent = 1;
		if (incPercent == undefined) incPercent = 1;
		
		this.speedUpTTL += Math.ceil(percent*150);
		if (this.speedUpTTL > 1000) this.speedUpTTL = 1000;
		else if (this.speedUpTTL < 0) this.speedUpTTL = 0;
		if (!Array.isArray(incPercent)) this.speedUpData.incPercent[this.speedUpData.incPercent] = (incPercent);
		else for(var key in incPercent) this.speedUpData.incPercent[this.speedUpData.incPercent] = (incPercent[key]);
	};
	
	//Speed down Player Car
	this.speedDownPlayerCar = function(percent)
	{
		if (percent == undefined) percent = 1;
		
		this.speedDown -= percent * 0.01;
		
		var minSpeed = this.isOnDirt ? 0.5*this.car.offroad2 : 0.75*this.car.offroad;
		if (!this.isOnRoad && this.slowDownManual) minSpeed *= 0.8;
		if (this.speedDown > 1) this.speedDown = 1;
		else if (this.speedDown < minSpeed) {
			if (this.speedDown + percent * 0.01 < minSpeed)
				this.speedDown += Math.abs(percent) * 0.02;
			else this.speedDown = minSpeed;
		}
	}
	
	//Move Player Car
	this.movePlayerCar = function(dir)
	{
		if (this.fuel <= 0) return false;
		this.car.x2 = this.car.x;
		this.car.y2 = this.car.y;
		
		var speedY = 5*(this.getSpeed()/10);
		if (Game.slowDownManual) speedY *= 1.5;
		this.car.y += dir*speedY;
		if (this.car.y-this.car.w/2 < 0) this.car.y = this.car.w/2;
		else if (this.car.y+this.car.w/2 > this.renderHeight) this.car.y = this.renderHeight-this.car.w/2;
	};
	
	//Fire Rocket
	this.fireRocket = function(obj, angle, speed, size)
	{
		if (!this.gameStarted || this.isPaused || this.gameOver) return false;
		if (obj == undefined) obj = this.car;
		if (angle == undefined) angle = Render.determineAngle(obj.x-10, obj.y2, obj.x, obj.y)-90;
		if (speed == undefined) speed = 5;
		if (size == undefined) size = 1;
		if (obj.type == "playerCar" && !(obj.rocket.canfire && obj.rocket.cooldown <= 0)) return false;
		
		var dirs = obj.rocket && obj.rocket.dir ? obj.rocket.dir : [0], dir;
		var hits = obj.rocket && obj.rocket.hits ? obj.rocket.hits : 1;
		for(var key in dirs)
		{
			dir = dirs[key];
			
			var rocket = {x: obj.x, y: obj.y, w: 25*size, h: 43*size, a: angle+dir, aOffset: dir,
				speed: speed, speedY: this.getSpeed(), color: Array.isArray(obj.color) ? obj.color[~~(Math.random()*obj.color.length)] : obj.color,
				type: obj.type, hits: hits};
			var newCord = Render.determineNewPoints(rocket.x, rocket.y, Render.images[obj.img].width/2, rocket.a+90);
			rocket.x = newCord.x; rocket.y = newCord.y;
			this.rockets[this.rockets.length] = rocket;
		}
		
		Render.audio["rocket"].currentTime = 0;
		Render.audio["rocket"].play();
		
		if (obj.type == "playerCar") obj.rocket.cooldown = obj.rocket.firerate;
	};
	
	//Add Score
	this.addScore = function(amt)
	{
		this.score += amt;
	};
	
	//Spawn Rival Car
	this.spawnRival = function()
	{
		var level = this.levels[this.levels.length-1];
		//if (!level.id.match(/^barrier/i)) return false;
		var startX = level.x+this.tileSize/2, startY = this.renderHeight/2;
		if (level.id.match(/lower/i)) startY = this.renderHeight*0.85;
		else if (level.id.match(/upper/i)) startY = this.renderHeight*0.15;
		
		var speeds2 = {"-5": startX, "5": startX, "-6": -150}, speeds = [], speed, canSpawn, otherRival, x, dir;
		var rivals = this.rivals;
		for(speed in speeds2)
		{
			speed = parseInt(speed); canSpawn = true;
			x = speeds2[speed]; dir = speed > 0 ? -1 : 1;
			
			for(var key in rivals)
			{
				otherRival = rivals[key];
				if (!canSpawn || otherRival.dir != dir) continue;
				
				if (Math.abs(x - otherRival.x) <= 300) canSpawn = false;
			}
			if (canSpawn) speeds[speeds.length] = speed;
		}
		if (speeds.length == 0) return false;
		
		speed = speeds[~~(Math.random() * speeds.length)];
		rival = {type: (["car", "bike"])[~~(Math.random()*2)], x: startX, y: startY, w: 70, h: 131, a: 0, img: "", speed: speed, carTracks: [],
				negTTL: 1000};
		if (rival.type == "bike") { rival.w = 44; rival.h = 100; }
		if (speed == -6)
		{
			speed = -(this.getSpeed()+0.5);
			if (speed >= -15) rival.x = -150;
			else speed = [-5,5][~~(Math.random() * 2)];
			rival.speed = speed;
		}
		rival.x2 = rival.x-1;
		rival.y2 = rival.y;
		rival.dir = rival.speed > 0 ? -1 : 1;
		
		var colors = ["black", "blue", "green", "red", "yellow"];
		do
		{
			rival.img = rival.type+"_"+colors[~~(colors.length*Math.random())];
		} while(rival.img == this.car.img);
		
		this.rivals[this.rivals.length] = rival;
		
		return canSpawn;
	};
	
	//Destroy this Rival Car
	this.destroyRival = function(rival)
	{
		rival.destroyed = true;
		this.addExplosion(rival.x, rival.y);
	};
	
	//Add Explosion
	this.addExplosion = function(x, y)
	{
		var explode = {x: x, y: y, on: 0, max: 8, ttl: 6, ttl0: 6};
		this.explosions[this.explosions.length] = explode;
		
		if (Render.audio["explosion1"].paused) Render.audio["explosion1"].play();
		else Render.audio["explosion2"].play();
	};
	
	
	//Trigger Gameover
	this.gameOverAction = function()
	{
		this.gameOverTriggered = true;
		
		GameOver.init({score: this.distance});
	};
	
	
	//Play Background Music
	this.audioBG = null;
	this.playBGMusic = function()
	{
		var index = ([1,2,3])[~~(Math.random()*3)];
		
		Render.audioStopAll();
		Render.audio["bg"+index].play();
		
		this.audioBG = Render.audio["bg"+index];
	};
	
	
	//Event Triggers
	this.heldKeys = {up: false, left: false, down: false, right: false, move: 0};
	this.eventTrigger = function(type, e)
	{
		switch(type)
		{
		case "keydown":
			switch(e.which)
			{
			default:
				//console.log(e.which);
			break;
			
			//Start Button
			case 13:
				if ($(".controlsdivs").is(":visible"))
				{
					$(".controlsdivs").hide();
				} else {
					if (this.gameStarted && !this.gameOver)
					{
						if (!this.isPaused)
						{
							this.isPaused = true;
							$("#pausemenu").show();
							Render.audio["lowGas"].pause();
						} else {
							this.isPaused = false;
							$("#pausemenu").hide();
						}
					} else if ($("#mainmenu").is(":visible")) {
						MainMenu.startGame();
					} else if ($("#mainmenu_game").is(":visible")) {
						Game.init();
					} else if ($("#leaderboard_newhighscore .buttons").is(":visible")) {
						$("#leaderboard_newhighscore .buttons a").click();
					} else if ($("#rewards_earned .buttons").is(":visible")) {
						$("#rewards_earned .buttons a").click();
					} else if ($("#rewards_countdown .buttons").is(":visible")) {
						$("#rewards_countdown .buttons a").click();
					} else if ($("#gameover").is(":visible")) {
						$("#gameover .button.red").click();
					} else if ($("#rewards_display").is(":visible")) {
						$("#rewards_display .button").click();
					} else if ($("#leaderboard").is(":visible")) {
						$("#leaderboard .button").click();
					}
				}
			break;

			case 37: this.heldKeys["left"] = true; break;
			case 38: this.heldKeys["up"] = true; break;
			case 39: this.heldKeys["right"] = true; break;
			case 40: this.heldKeys["down"] = true; break;
			
			//A Button
			case 65: case 81: case 87: case 69: case 82:
				if ($(".controlsdivs").is(":visible"))
				{
					$(".controlsdivs").hide();
				} else {
					if (this.gameStarted && !this.gameOver)
					{
						if (!this.isPaused)
						{
							this.heldKeys["a"] = true;
						} else {
							$("#pausemenu .button.red").click();
						}
					} else {
						if (this.heldKeys["a2"]) return false;
						this.heldKeys["a2"] = true;
						
						if (e.which == 65)
						{
							if ($("#mainmenu").is(":visible")) {
								$("#mainmenu .button.red").click();
							} else if ($("#mainmenu_game").is(":visible")) {
								$("#mainmenu_game .button.red").click();
							} else if ($("#leaderboard_newhighscore .buttons").is(":visible")) {
								$("#leaderboard_newhighscore .buttons a").click();
							} else if ($("#rewards_earned .buttons").is(":visible")) {
								$("#rewards_earned .buttons a").click();
							} else if ($("#rewards_countdown .buttons").is(":visible")) {
								$("#rewards_countdown .buttons a").click();
							} else if ($("#gameover").is(":visible")) {
								$("#gameover .button.red").click();
							} else if ($("#rewards_display").is(":visible")) {
								$("#rewards_display .button").click();
							} else if ($("#leaderboard").is(":visible")) {
								$("#leaderboard .button").click();
							}
						}
					}
				}
			break;
			
			//B Button
			case 66:
			case 83:
				if (this.gameStarted && !this.gameOver)
				{
					this.slowDownManual = true;
				}
			break;
			
			//X | Y
			case 68:
			case 88: case 89:
				if (this.gameStarted && !this.gameOver && !this.isPaused)
				{
					if (this.car.honk) Render.audio["honk"].play();
					if (this.car.special)
					{
						this.car.special.active = !this.car.special.active;
						this.car.special.modeChange(this.car);
					}
				}
			break;
			}
		break;
		
		case "keyup":
			switch(e.which)
			{
			//default: console.log(e.which); break;
			
			//Left
			case 37:
				this.heldKeys["left"] = false;
				if ($("#leaderboard").is(":visible"))
				{
					Leaderboard.switchArea(-1);
				}
				
				var moveDir = -1;
				if (!$(".controlsdivs").is(":visible"))
				{
					if (this.gameStarted && !this.gameOver)
					{
						if (this.isPaused) MainMenu.selectButtonMove($("#pausemenu"), moveDir);
					} else {
						if ($("#mainmenu").is(":visible")) MainMenu.selectButtonMove($("#mainmenu"), moveDir);
						else if ($("#mainmenu_game").is(":visible")) MainMenu.selectButtonMove($("#mainmenu_game"), moveDir);
						else if ($("#leaderboard_newhighscore .buttons").is(":visible"))
							MainMenu.selectButtonMove($("#leaderboard_newhighscore"), moveDir);
						else if ($("#rewards_earned .buttons").is(":visible")) MainMenu.selectButtonMove($("#rewards_earned"), moveDir);
						else if ($("#rewards_countdown .buttons").is(":visible")) MainMenu.selectButtonMove($("#rewards_countdown"), moveDir);
						else if ($("#gameover").is(":visible")) MainMenu.selectButtonMove($("#gameover"), moveDir);
					}
				}
			break;
			
			//Up
			case 38:
				this.heldKeys["up"] = false;
				if ($("#leaderboard").is(":visible"))
				{
					Leaderboard.moveScoresList(-1);
				}
				
				var moveDir = -1;
				if (!$(".controlsdivs").is(":visible"))
				{
					if (this.gameStarted && !this.gameOver)
					{
						if (this.isPaused) MainMenu.selectButtonMove($("#pausemenu"), moveDir);
					} else {
						if ($("#mainmenu").is(":visible")) MainMenu.selectButtonMove($("#mainmenu"), moveDir);
						else if ($("#mainmenu_game").is(":visible")) MainMenu.selectButtonMove($("#mainmenu_game"), moveDir);
						else if ($("#leaderboard_newhighscore .buttons").is(":visible"))
							MainMenu.selectButtonMove($("#leaderboard_newhighscore"), moveDir);
						else if ($("#rewards_earned .buttons").is(":visible")) MainMenu.selectButtonMove($("#rewards_earned"), moveDir);
						else if ($("#rewards_countdown .buttons").is(":visible")) MainMenu.selectButtonMove($("#rewards_countdown"), moveDir);
						else if ($("#gameover").is(":visible")) MainMenu.selectButtonMove($("#gameover"), moveDir);
					}
				}
			break;
			
			//Right
			case 39:
				this.heldKeys["right"] = false;
				if ($("#leaderboard").is(":visible"))
				{
					Leaderboard.switchArea(1);
				}
				
				var moveDir = 1;
				if (!$(".controlsdivs").is(":visible"))
				{
					if (this.gameStarted && !this.gameOver)
					{
						if (this.isPaused) MainMenu.selectButtonMove($("#pausemenu"), moveDir);
					} else {
						if ($("#mainmenu").is(":visible")) MainMenu.selectButtonMove($("#mainmenu"), moveDir);
						else if ($("#mainmenu_game").is(":visible")) MainMenu.selectButtonMove($("#mainmenu_game"), moveDir);
						else if ($("#leaderboard_newhighscore .buttons").is(":visible"))
							MainMenu.selectButtonMove($("#leaderboard_newhighscore"), moveDir);
						else if ($("#rewards_earned .buttons").is(":visible")) MainMenu.selectButtonMove($("#rewards_earned"), moveDir);
						else if ($("#rewards_countdown .buttons").is(":visible")) MainMenu.selectButtonMove($("#rewards_countdown"), moveDir);
						else if ($("#gameover").is(":visible")) MainMenu.selectButtonMove($("#gameover"), moveDir);
					}
				}
			break;
			
			//Down
			case 40:
				this.heldKeys["down"] = false;
				if ($("#leaderboard").is(":visible"))
				{
					Leaderboard.moveScoresList(1);
				}
				
				var moveDir = 1;
				if (!$(".controlsdivs").is(":visible"))
				{
					if (this.gameStarted && !this.gameOver)
					{
						if (this.isPaused) MainMenu.selectButtonMove($("#pausemenu"), moveDir);
					} else {
						if ($("#mainmenu").is(":visible")) MainMenu.selectButtonMove($("#mainmenu"), moveDir);
						else if ($("#mainmenu_game").is(":visible")) MainMenu.selectButtonMove($("#mainmenu_game"), moveDir);
						else if ($("#leaderboard_newhighscore .buttons").is(":visible"))
							MainMenu.selectButtonMove($("#leaderboard_newhighscore"), moveDir);
						else if ($("#rewards_earned .buttons").is(":visible")) MainMenu.selectButtonMove($("#rewards_earned"), moveDir);
						else if ($("#rewards_countdown .buttons").is(":visible")) MainMenu.selectButtonMove($("#rewards_countdown"), moveDir);
						else if ($("#gameover").is(":visible")) MainMenu.selectButtonMove($("#gameover"), moveDir);
					}
				}
			break;
			
			
			//A
			case 65: case 81: case 87: case 69: case 82:
				this.heldKeys["a"] = false; this.heldKeys["a2"] = false;
			break;
			
			//B Button
			case 66:
			case 83:
				if (this.gameStarted && !this.gameOver)
				{
					this.slowDownManual = false;
				}
			break;
			
			//X | Y
			case 68:
			case 88: case 89:
			break;
			}
		break;
		
		case "held":
			if (this.heldKeys["move"])
				this.movePlayerCar(this.heldKeys["move"]);
			else if (this.heldKeys["up"] || this.heldKeys["down"])
				this.movePlayerCar(this.heldKeys["up"] ? -1 : 1);
			else {
				this.car.x2 = this.car.x;
				this.car.y2 = this.car.y;
			}
			
			if (this.heldKeys["a"]) this.fireRocket();
		break;
		
		case "held2":
			var amt = ~~(Math.abs(e.y) * 100);
			if (amt % 20 > 0) amt += 20 - (amt % 20);
			amt = amt/100; if (amt < 0.05) amt = 0;
			
			this.heldKeys["move"] = e.y > 0 ? amt : -amt;
		break;
		}
	};
};
var Game = new Game();

function shuffleArray(array) {
    for (var i = array.length - 1; i > 0; i--) {
        var j = Math.floor(Math.random() * (i + 1));
        var temp = array[i];
        array[i] = array[j];
        array[j] = temp;
    }
    return array;
}