function InputBank()
{
	this.vault = {};
	this.vaultCount = 0;
	this.vaultArchive = [];
	this.vaultGroups = {};

	this.heldButtons = {};
	this.releaseButtons = {};
	
	this.remoteDisconectValue = -1000;
	
	this.wiiRemoteMode = typeof nwf !== "undefined" ? nwf.input.WiiRemote.MODE_LITE : null;
	
	this.NWFButton = typeof nwf !== "undefined" ? nwf.input.ControllerButton : null;
	if (this.NWFButton)
	{
		this.store = {
			"GAMEPAD": {
				start: [this.NWFButton.GAMEPAD_PLUS],
				select: [this.NWFButton.GAMEPAD_MINUS],
				a: [this.NWFButton.GAMEPAD_A],
				b: [this.NWFButton.GAMEPAD_B],
				x: [this.NWFButton.GAMEPAD_X],
				y: [this.NWFButton.GAMEPAD_Y],
				r: [this.NWFButton.GAMEPAD_R],
				l: [this.NWFButton.GAMEPAD_L],
				r2: [this.NWFButton.GAMEPAD_ZR],
				l2: [this.NWFButton.GAMEPAD_ZL],
				r3: [this.NWFButton.GAMEPAD_R_DOWN],
				l3: [this.NWFButton.GAMEPAD_L_DOWN],
				up: [this.NWFButton.GAMEPAD_UP],
				right: [this.NWFButton.GAMEPAD_RIGHT],
				down: [this.NWFButton.GAMEPAD_DOWN],
				left: [this.NWFButton.GAMEPAD_LEFT]
			},
			"WIIREMOTE": {
				start: [this.NWFButton.WII_REMOTE_PLUS],
				select: [this.NWFButton.WII_REMOTE_MINUS],
				a: [this.NWFButton.WII_REMOTE_A],
				b: [this.NWFButton.WII_REMOTE_B],
				up: [this.NWFButton.WII_REMOTE_UP],
				right: [this.NWFButton.WII_REMOTE_RIGHT],
				down: [this.NWFButton.WII_REMOTE_DOWN],
				left: [this.NWFButton.WII_REMOTE_LEFT],
				1: [this.NWFButton.WII_REMOTE_1],
				2: [this.NWFButton.WII_REMOTE_2],
				disconnect: [this.remoteDisconectValue]
			}
		};
		this.storeIgnore = {
			"GAMEPAD": [this.NWFButton.GAMEPAD_POWER, this.NWFButton.GAMEPAD_SYNC],
			"WIIREMOTE": []
		};
	} else {
		this.store = {
			"GAMEPAD": {
				"b": ["b"],
				"a": ["a"],
				"x": ["x"],
				"y": ["y"],
				"l": ["l"],
				"r": ["r"],
				"up": ["up"],
				"down": ["down"],
				"left": ["left"],
				"right": ["right"],
				"start": ["start"]
			},
			"WIIREMOTE": {
				"b": ["b"],
				"a": ["a"],
				"x": ["x"],
				"y": ["y"],
				"up": ["up"],
				"down": ["down"],
				"left": ["left"],
				"right": ["right"],
				"start": ["start"]
			}
		};
		this.storeIgnore = {
			"GAMEPAD": [],
			"WIIREMOTE": []
		};
	}
	
	//Init - Install the input listeners
	this.init = function()
	{
		setInterval(function()
		{
			InputBank.pressReleaseCheck();
		}, 15);
		
		//Gamepad
		if (typeof nwf !== "undefined")
		{
			var gp0Buttons = nwf.input.WiiUGamePad.getController(0).buttons;
			gp0Buttons.addEventListener(nwf.events.ButtonControlEvent.PRESS, function(e)
			{
				if (jQuery.inArray(e.button, InputBank.storeIgnore["GAMEPAD"]) != -1) return true;
				
				InputBank.checkForAction("GAMEPAD", "gp0", e.button);
			}, this);
			
			InputBank.heldButtons["gp0"] = [];
			InputBank.releaseButtons["gp0"] = [];
			gp0Buttons.addEventListener(nwf.events.ButtonControlEvent.PRESS, function(e)
			{
				if (jQuery.inArray(e.button, InputBank.storeIgnore["GAMEPAD"]) != -1) return true;
				
				if (jQuery.inArray(e.button, InputBank.heldButtons["gp0"]) == -1)
					InputBank.heldButtons["gp0"].push(e.button);
			}, this);
			gp0Buttons.addEventListener(nwf.events.ButtonControlEvent.RELEASE, function(e)
			{
				if (jQuery.inArray(e.button, InputBank.storeIgnore["GAMEPAD"]) != -1) return true;
				
				var map = [];
				for(var key in InputBank.heldButtons["gp0"])
					if (jQuery.inArray(e.button, InputBank.heldButtons["gp0"]) == -1)
						map.push(InputBank.heldButtons["gp0"]);
				InputBank.heldButtons["gp0"] = map;
				InputBank.releaseButtons["gp0"].push(e.button);
			}, this);
			
			//Gamepad Left/Right Stick
			var gpLStick = nwf.input.WiiUGamePad.getController( 0 ).leftStick;
			gpLStick.addEventListener(nwf.events.MovementControlEvent.MOVE, function(e)
			{
				InputBank.checkForActionStick("gp0", "left", e.movementX, e.movementY);
				return true;
			}, this);
			var gpRStick = nwf.input.WiiUGamePad.getController( 0 ).rightStick;
			gpRStick.addEventListener(nwf.events.MovementControlEvent.MOVE, function(e)
			{
				InputBank.checkForActionStick("gp0", "right", e.movementX, e.movementY);
				return true;
			}, this);
			
			
			if (0) {
			//Wii Remotes
			for(var i=0; i<=3; i++)
			{
				addWiiRemoteConnected(i);
				addWiiRemoteControll(i);
				addWiiRemoteControllPRESSRELEASE(i);
			}
			//Be on lookout whenever a Wii Remote is connected
			function addWiiRemoteConnected(controller)
			{
				var remote = nwf.input.WiiRemote.getController(controller);
				remote.mode = InputBank.wiiRemoteMode;//nwf.input.WiiRemote.MODE_FULL;//LITE;
				remote.addEventListener(nwf.events.ControllerEvent.CONTROLLER_CONNECTED, function(e)
				{
					if (e.target && e.target.connected)
					{
						var remote = nwf.input.WiiRemote.getController(e.target.channel);
						remote.mode = InputBank.wiiRemoteMode;//nwf.input.WiiRemote.MODE_FULL;//LITE;
					}
				}, this);
				remote.addEventListener(nwf.events.ControllerEvent.CONTROLLER_DISCONNECTED, function(e)
				{
					if (e.target)
					{
						InputBank.checkForAction("WIIREMOTE", "wiiremote"+controller, InputBank.remoteDisconectValue);
					}
				}, this);
			};
			//One time press
			function addWiiRemoteControll(controller)
			{
				var remote = nwf.input.WiiRemote.getController(controller);
				var gp0Buttons = remote.buttons;
				gp0Buttons.addEventListener(nwf.events.ButtonControlEvent.PRESS, function(e)
				{
					if (jQuery.inArray(e.button, InputBank.storeIgnore["WIIREMOTE"]) != -1) return true;
					
					InputBank.checkForAction("WIIREMOTE", "wiiremote"+controller, e.button);
				}, this);
			};
			//Record when something held/let go
			function addWiiRemoteControllPRESSRELEASE(controller)
			{
				InputBank.heldButtons["wiiremote"+controller] = [];
				InputBank.releaseButtons["wiiremote"+controller] = [];
				
				var gp0Buttons = nwf.input.WiiRemote.getController(controller).buttons;
				gp0Buttons.addEventListener(nwf.events.ButtonControlEvent.PRESS, function(e)
				{
					if (jQuery.inArray(e.button, InputBank.storeIgnore["WIIREMOTE"]) != -1) return true;
					
					if (jQuery.inArray(e.button, InputBank.heldButtons["wiiremote"+controller]) == -1)
						InputBank.heldButtons["wiiremote"+controller].push(e.button);
				}, this);
				gp0Buttons.addEventListener(nwf.events.ButtonControlEvent.RELEASE, function(e)
				{
					if (jQuery.inArray(e.button, InputBank.storeIgnore["WIIREMOTE"]) != -1) return true;
					
					var map = [];
					for(var key in InputBank.heldButtons["wiiremote"+controller])
						if (e.button != InputBank.heldButtons["wiiremote"+controller][key])
							map.push(InputBank.heldButtons["wiiremote"+controller][key]);
					InputBank.heldButtons["wiiremote"+controller] = map;
					InputBank.releaseButtons["wiiremote"+controller].push(e.button);
				}, this);
			};
			}
			
		//Web Version
		} else if (1) {
			InputBank.heldButtons["gp0"] = [];
			InputBank.releaseButtons["gp0"] = [];
			$("body").keydown(function(e)
			{
				var button = InputBank.returnButton(e.which);
				if (button >= 0 && button <= 9) return true;
				
				if (button && jQuery.inArray(button, InputBank.heldButtons["gp0"]) == -1)
					InputBank.heldButtons["gp0"].push(button);
			}).keyup(function(e)
			{
				var button = InputBank.returnButton(e.which);
				if (button >= 0 && button <= 9) return true;
				if (button)
				{
					InputBank.checkForAction("GAMEPAD", "gp0", button);
					
					var map = [];
					for(var key in InputBank.heldButtons["gp0"])
						if (InputBank.heldButtons["gp0"][key] != button)
							map.push(InputBank.heldButtons["gp0"][key]);
					InputBank.heldButtons["gp0"] = map;
					InputBank.releaseButtons["gp0"].push(button);
				}
			});
			
			InputBank.heldButtons["wiiremote0"] = [];
			InputBank.releaseButtons["wiiremote0"] = [];
			$("body").keydown(function(e)
			{
				var button = InputBank.returnButton(e.which);
				if (!(button >= 0 && button <= 9)) return true;
				switch(parseInt(button))
				{
				case 1: button = "x"; break;
				case 2: button = "down"; break;
				case 3: button = "y"; break;
				case 4: button = "left"; break;
				case 5: button = "start"; break;
				case 6: button = "right"; break;
				case 7: button = "a"; break;
				case 8: button = "up"; break;
				case 9: button = "b"; break;
				}
				
				if (button && jQuery.inArray(button, InputBank.heldButtons["wiiremote0"]) == -1)
					InputBank.heldButtons["wiiremote0"].push(button);
			}).keyup(function(e)
			{
				var button = InputBank.returnButton(e.which);
				if (!(button >= 0 && button <= 9)) return true;
				switch(parseInt(button))
				{
				case 1: button = "x"; break;
				case 2: button = "down"; break;
				case 3: button = "y"; break;
				case 4: button = "left"; break;
				case 5: button = "start"; break;
				case 6: button = "right"; break;
				case 7: button = "a"; break;
				case 8: button = "up"; break;
				case 9: button = "b"; break;
				}
				
				if (button)
				{
					InputBank.checkForAction("WIIREMOTE", "wiiremote0", button);
					
					var map = [];
					for(var key in InputBank.heldButtons["wiiremote0"])
						if (InputBank.heldButtons["wiiremote0"][key] != button)
							map.push(InputBank.heldButtons["wiiremote0"][key]);
					InputBank.heldButtons["wiiremote0"] = map;
					InputBank.releaseButtons["wiiremote0"].push(button);
				}
			});
		}
	};
	
	//Add a new vault entry
	//All functions will result in three params returned when action occurs (clickID, vaultEntry, type)
	this.add = function(data)
	{
		if (data.id == undefined || data.id == "") return false;
		if (data.allowoverwrite == undefined) data.allowoverwrite = false;
		if (this.vault[data.id] != undefined && !data.allowoverwrite) return true;

		if (data.controller == undefined) data.controller = "gp0";
		if (data.limit == undefined) data.limit = 1;
		
		this.vault[data.id] = data;
		this.vaultCount++;
		
		if (data.group != undefined)
		{
			if (this.vaultGroups[data.group] == undefined) this.vaultGroups[data.group] = [];
			this.vaultGroups[data.group].push(data.id);
		}
		
		return true;
	};
	
	//Clear a vault entry
	this.clear = function(id)
	{
		var data = this.vault[id];
		if (data && data.group)
		{
			var groupids = [];
			for(var key in this.vaultGroups[data.group])
				if (this.vaultGroups[data.group][key] != id)
					groupids.push(this.vaultGroups[data.group][key]);
			if (groupids.length > 0) this.vaultGroups[data.group] = groupids;
			else delete this.vaultGroups[data.group];
		}
		
		delete this.vault[id];
		this.vaultCount--;
	};
	
	//Clear this group from vault
	this.clearGroup = function(group)
	{
		if (this.vaultGroups[group] == undefined) return false;
		
		for(var key in this.vaultGroups[group])
		{
			delete this.vault[this.vaultGroups[group][key]];
			this.vaultCount--;
		}
		
		delete this.vaultGroups[group];
	};
	
	//Clear all in the vault
	this.clearAll = function()
	{
		this.vault = {};
		this.vaultCount = 0;
		this.vaultGroups = {};
	};
	
	//Archives the current vault
	this.archive = function()
	{
		this.vaultArchive.unshift(this.vault);
		this.clearAll();
	};
	
	//Restore the latest archived vault
	this.unarchive = function()
	{
		this.vault = this.vaultArchive.shift();
		this.vaultCount = 0;
		var vault;
		for(var key in this.vault)
		{
			vault = this.vault[key];
			if (vault.group != undefined)
			{
				if (this.vaultGroups[vault.group] == undefined) this.vaultGroups[vault.group] = [];
				this.vaultGroups[vault.group].push(vault.id);
			}
			this.vaultCount++;
		}
	};
	
	this.returnButton = function(code)
	{
		//console.log(code);
		var button = "";
		switch(code)
		{
		case 65: button = "a"; break;
		case 66: button = "b"; break;
		case 83: button = "b"; break;//s
		case 68: button = "x"; break;//d
		case 70: button = "y"; break;//f
		case 88: button = "x"; break;
		case 89: button = "y"; break;
		case 81: button = "l"; break;//q
		case 87: button = "r"; break;//w
		case 37: button = "left"; break;
		case 38: button = "up"; break;
		case 39: button = "right"; break;
		case 40: button = "down"; break;
		case 13: button = "start"; break;
		case 32: button = "start"; break;
		
		case 97: button = "1"; break;
		case 98: button = "2"; break;
		case 99: button = "3"; break;
		case 100: button = "4"; break;
		case 101: button = "5"; break;
		case 102: button = "6"; break;
		case 103: button = "7"; break;
		case 104: button = "8"; break;
		case 105: button = "9"; break;
		}
		
		return button;
	};
	
	
	//Check for Press and Release buttons
	this.pressReleaseCheck = function()
	{
		if (this.vaultCount == 0) return true;
		
		var buttons, button;
		
		//Check for released buttons
		for(var controller in this.releaseButtons)
		{
			buttons = this.releaseButtons[controller];
			if (buttons.length == 0) continue;
			
			for(var key in buttons)
			{
				button = buttons[key];
				//console.log("-"+button);
				
				//Make sure not in held state
				if (jQuery.inArray(button, this.heldButtons[controller]) == -1)
					this.checkForAction(controllerType(controller), controller, button, "release");
			}
			
			this.releaseButtons[controller] = [];
		}
		
		//Check held buttons
		for(var controller in this.heldButtons)
		{
			buttons = this.heldButtons[controller];
			if (buttons.length == 0) continue;
			
			for(var key in buttons)
			{
				button = buttons[key];
				//console.log("+"+button);
				
				this.checkForAction(controllerType(controller), controller, button, "held");
			}
		}
		
		function controllerType(controller)
		{
			var rtr = "";
			if (controller.match(/gp/i)) rtr = "GAMEPAD";
			else rtr = "WIIREMOTE";
			
			return rtr;
		};
	};
	
	//Action
	this.checkForAction = function(controllerType, controller, action, actionType)
	{
		if (this.vaultCount == 0) return true;
		
		if (actionType == undefined) actionType = "action";

		var entry, actionCount, doContinue;
		for(var ID in this.vault)
		{
			if (this.vault[ID] != undefined && this.vault[ID][actionType] != undefined)
			{
				doContinue = true;
				entry = this.vault[ID];
				if (typeof entry.controller == "string" && entry.controller != "any" && entry.controller != controller) doContinue = false;
				else if (typeof entry.controller == "object")
				{
					doContinue = false;
					for(var key in entry.controller)
						if (entry.controller[key] == controller)
							doContinue = true;
				}
				if (!doContinue) continue;
				
				if (entry.type == "any" || (typeof entry.type == "string" && jQuery.inArray(action, this.store[controllerType][entry.type]) != -1))
				{
					this.doAction(ID, entry.type, controller, actionType);
					
				} else if (typeof entry.type == "object") {
					actionCount = 0;
					for(var key in entry.type)
					{
						if (actionCount >= entry.limit) continue;
						if (jQuery.inArray(action, this.store[controllerType][entry.type[key]]) != -1)
						{
							this.doAction(ID, entry.type[key], controller, actionType);
							actionCount++;
						}
					}
				}
			}
		}
	};
	
	//Action for Sticks
	this.checkForActionStick = function(controller, action, x, y)
	{
		if (this.vaultCount == 0) return true;
		
		var entry, actionCount, doContinue;
		for(var ID in this.vault)
		{
			if (this.vault[ID] != undefined && this.vault[ID]["stick"] != undefined)
			{
				doContinue = true;
				entry = this.vault[ID];
				if (typeof entry.controller == "string" && entry.controller != "any" && entry.controller != controller) doContinue = false;
				else if (typeof entry.controller == "object")
				{
					doContinue = false;
					for(var key in entry.controller)
						if (entry.controller[key] == controller)
							doContinue = true;
				}
				if (!doContinue) continue;
				
				if (entry.type == "any" || (typeof entry.type == "string" && action == entry.type))
				{
					this.doAction2(ID, entry.type, controller, x, y);
					
				} else if (typeof entry.type == "object") {
					actionCount = 0;
					for(var key in entry.type)
					{
						if (actionCount >= entry.limit) continue;
						if (action == entry.type[key])
						{
							this.doAction2(ID, entry.type[key], controller, x, y);
							actionCount++;
						}
					}
				}
			}
		}
	};
	
	//Action function
	this.doAction = function(ID, type, controller, actionType)
	{
		var entry = this.vault[ID];
		
		if (entry && entry[actionType])
			entry[actionType](ID, entry, type, controller);
	};
	this.doAction2 = function(ID, type, controller, x, y)
	{
		var entry = this.vault[ID];
		
		if (entry && entry["stick"])
			entry["stick"](ID, entry, type, controller, x, y);
	};
};
var InputBank = new InputBank();