function Leaderboard()
{
	this.isOpen = false; this.isOpenNewScore = false;
	this.container;
	
	this.area = "offline"; this.areas = ["offline", "all", "friends"];
	
	this.myTopScores = {"": -1};
	this.scores = [{name:"ZNA", score:1000}, {name:"GWW", score:900}, {name:"CAT", score:800}, {name:"DOG", score:700},
	               {name:"LRY", score:600}, {name:"EML", score:500}, {name:"AMY", score:400}, {name:"RAC", score:300},
	               {name:"ALI", score:200}, {name:"JOE", score:100}];
	
	this.onlineScores = {"all": [], "friends": [], "user": []};
	this.onlineFuncsLimit = 15; this.onlineFuncsTimeLimit = 6*60*1000;
	this.onlineFuncsLimitTypes = {"": 11, get: 11, put: 15};
	this.onlineFuncsTimes = [];
	
	this.scoresOffsetY = 0; this.scoresTotal = 0; this.scoresTotalLimit = 0;
	
	//Initation
	this.init = function(closeFunc)
	{
		//New High Score Popup Functions
		var popup = $("#leaderboard_newhighscore");
		popup.find(".initials").click(function(){ Leaderboard.initialsOn($(this).closest(".initials")); }).end()
			.find(".initials .arrow-up").click(function(){ Leaderboard.initialsArrow($(this).closest(".initials"), 1); }).end()
			.find(".initials .arrow-down").click(function(){ Leaderboard.initialsArrow($(this).closest(".initials"), -1); }).end();
		
		this.container = $("#leaderboard");
	};

	//Open the Dialog
	this.endFunc = null;
	this.open = function(endFunc)
	{
		if (this.isOpen) return false;
		
		this.isOpen = true;
		this.container.show();
		if (endFunc) this.endFunc = endFunc;
		
		if (!Render.actCanInternet || Render.act.accountType == "local")
		{
			this.area = "offline";
			this.container.find(".arrows").hide();
		} else {
			this.container.find(".arrows").show();
		}
		
		var table = $("#highscores_table tbody");
		table.html("<tr><td colspan='3' style='text-align:left;'>Gathering Ranks...</td></tr>");
		$("#leaderboard .arrows2").hide();
		
		this.registerNewScore(0, function()
		{
			Leaderboard.getScores();
		});
	};
	
	//Close the Dialog
	this.close = function()
	{
		if (!this.isOpen || this.isGettingScores) return false;
		
		this.isOpen = false;
		this.container.hide();
		
		if (this.endFunc)
		{
			this.endFunc();
			this.endFunc = null;
		}
	};
	
	//Get Scores
	this.getScores = function()
	{
		if (Render.actCanInternet && Render.act.accountType != "local")
		{
			this.onlineConnect(0,
				function()
				{
					Leaderboard.getScores2();
				}, function()
				{
					Leaderboard.getScores2();
				});
		} else {
			Leaderboard.getScores2();
		}
	};
	this.getScores2 = function()
	{
		var title = "";
		switch(this.area)
		{
		default: case "offline":
			title = "High Scores";
		break;
		
		case "all":
			title = "Online Rankings";
		break;
		
		case "friends":
			title = "Friends Rankings";
		break;
		}
		this.container.find(".title").html(title);
		$("#leaderboard .arrows2").hide();
		
		this.scoresOffsetY = 0;
		switch(this.area)
		{
		default: case "offline":
			this.getScoresDisplay(this.scores);
		break;
		
		case "all":
		case "friends":
			var table = $("#highscores_table tbody");
			table.html("<tr><td colspan='3' style='text-align:left;'>Gathering Ranks...</td></tr>");
			
			var settings = {};
			settings.rankingMode = (this.area == "all" ? nwf.nex.RankingMode.RANGE : nwf.nex.RankingMode.FRIEND_RANGE);
			this.getScoresOnline(0, settings, {}, this.area, function()
				{
					Leaderboard.getScoresDisplay(Leaderboard.onlineScores[Leaderboard.area]);
				}, function()
				{
					Leaderboard.getScoresDisplay(Leaderboard.onlineScores[Leaderboard.area]);
				});
		break;
		}
	};
	this.getScoresDisplay = function(scores)
	{
		var table = $("#highscores_table tbody");
		table.html("");
		
		var foundMe = false;
		var myAct = nwf.act.NintendoAccountManager.getInstance().getActiveAccount();
		var playerName = myAct.accountID ? myAct.accountID : "Player";
		
		var score, tr;
		for(var rank in scores)
		{
			score = scores[rank];
			if (score.name == playerName) foundMe = true;
			
			tr = $("<tr class='rank_"+rank+(score.name == playerName ? " user" : "")+"' data-rank='"+score.order+"' />")
				.append($("<td />").html(parseInt(rank)+1))
				.append($("<td class='name' />").html(score.name))
				.append($("<td />").html(Render.numberFormat(score.score)));
			
			table.append(tr);
		}
		$("#leaderboard .arrows2").hide();
		if (scores.length == 0)
		{
			table.html("<tr><td colspan='3' style='text-align:left;'>No Rankings Found.</td></tr>");
		} else {
			if (this.area == "all" || this.area == "friends")
			{
				var limit = 10, count = scores.length;
				if (this.area == "all" && this.onlineScores["user"] && this.onlineScores["user"].length && !foundMe) limit = 8;
				this.scoresTotal = count; this.scoresTotalLimit = limit;
				
				if (count > limit)
				{
					$("#leaderboard .arrows2").show();
					var listFrom = this.scoresOffsetY+1, listTo = this.scoresOffsetY+limit+1;
					table.find("tr").hide();
					for(var rank=listFrom; rank<listTo; rank++)
						table.find("[data-rank='"+rank+"']").show();
				}
			}
			
			if (this.area == "all" && this.onlineScores["user"] && this.onlineScores["user"].length && !foundMe)
			{
				tr = $("<tr><td colspan='3' style='text-align:center;'>...</td></tr>");
				table.append(tr);
				
				score = this.onlineScores["user"][0];
				tr = $("<tr class='rank_"+score.order+" user' data-rank='"+score.order+"' />").append($("<td />").html(score.order))
				.append($("<td class='name' />").html(score.name))
				.append($("<td />").html(Render.numberFormat(score.score)));
				table.append(tr);
			}
		}
	};
	
	//Switch Area of Rankings
	this.switchArea = function(dir)
	{
		if (this.isGettingScores) return false;
		
		var index = this.areas.indexOf(this.area);
		index += dir;
		if (index < 0) index = this.areas.length-1;
		if (index > this.areas.length-1) index = 0;
		
		if (!Render.actCanInternet || Render.act.accountType == "local") index = 0;
		this.area = this.areas[index];
		
		this.getScores();
	};
	
	//Move up or down the Rankings
	//this.scoresOffsetY = 0; this.scoresTotal = 0; this.scoresTotalLimit = 0;
	this.moveScoresList = function(dir)
	{
		if (this.isGettingScores || this.area == "offline") return false;
		
		this.scoresOffsetY += dir;
		if (this.scoresOffsetY < 0) this.scoresOffsetY = 0;
		if (this.scoresOffsetY+this.scoresTotalLimit > this.scoresTotal)
			this.scoresOffsetY = this.scoresTotal - this.scoresTotalLimit;
		
		this.getScoresDisplay(this.onlineScores[this.area]);
	};
	
	
	//Register new Score
	this.registerNewScore_Data = {};
	this.registerNewScore_endFunc;
	this.registerNewScore = function(score, endFunc)
	{
		this.isOpenNewScore = false;
		
		//Online Check
		if (Render.actCanInternet)
		{
			var myAct = nwf.act.NintendoAccountManager.getInstance().getActiveAccount();
			if (myAct.accountType != "local")
			{
				this.registerNewScore_Data.playerName = myAct.accountID ? myAct.accountID : "Player";
				this.registerNewScore_Data.score = score;
				this.registerNewScore_Data.endFunc = endFunc;
				
				if (this.myTopScores[this.registerNewScore_Data.playerName] == undefined ||
					parseInt(this.myTopScores[this.registerNewScore_Data.playerName]) < score)
				{
					this.onlineConnect(0,
						function()
						{
							Leaderboard.uploadScore(score, 0, [Leaderboard.registerNewScore_Data.playerName],
								function()
								{
									var score = parseInt(Leaderboard.registerNewScore_Data.score), endFunc = Leaderboard.registerNewScore_Data.endFunc;
									var playerName = Leaderboard.registerNewScore_Data.playerName;
									
									//Leaderboard.registerNewScore_Data = {};
									Leaderboard.registerNewScore_offline(score, endFunc);
								}, function()
								{
									var score = parseInt(Leaderboard.registerNewScore_Data.score), endFunc = Leaderboard.registerNewScore_Data.endFunc;
									var playerName = Leaderboard.registerNewScore_Data.playerName;
									//Leaderboard.registerNewScore_Data = {};
									Leaderboard.registerNewScore_offline(score, endFunc);
								});
						}, function()
						{
							var score = parseInt(Leaderboard.registerNewScore_Data.score), endFunc = Leaderboard.registerNewScore_Data.endFunc;
							var playerName = Leaderboard.registerNewScore_Data.playerName;
							//Leaderboard.registerNewScore_Data = {};
							Leaderboard.registerNewScore_offline(score, endFunc);
						});
				} else {
					this.registerNewScore_offline(score, endFunc);
				}
			} else {
				this.registerNewScore_offline(score, endFunc);
			}
		} else {
			this.registerNewScore_offline(score, endFunc);
		}
	};
	this.registerNewScore_offline = function(score, endFunc)
	{
		var isNewHighScore = false;
		for(var pi in this.scores)
			if (parseInt(this.scores[pi].score) < score)
				isNewHighScore = true;
		if (!isNewHighScore)
		{
			if (endFunc) endFunc();
			return false;
		}
		
		this.registerNewScore_endFunc = endFunc;
		
		var popup = $("#leaderboard_newhighscore");
		popup.show().find(".score").html(score).end()
			.find(".initials").removeClass("on").filter("[data-index='0']").addClass("on").find(".initial").text("A");
		this.registerNewScore_Data.score = score;
		this.isOpenNewScore = true;
		
		return true;
	};
	this.registerNewScore2 = function()
	{
		var popup = $("#leaderboard_newhighscore");
		popup.hide();
		this.isOpenNewScore = false;
		
		var initials = "";
		var score = this.registerNewScore_Data.score;
		popup.find(".initials").each(function()
		{
			initials += $(this).find(".initial").text();
		});
		
		this.scores[this.scores.length] = {name: initials, score: this.registerNewScore_Data.score};
		this.scores.sort(function(a, b)
		{
			return b.score - a.score;
		});
		this.scores.pop();
		
		Render.saveData.leaderboard = this.scores;
		Render._saveDataUpdate(Render.saveData, true);
		
		if (this.registerNewScore_endFunc)
		{
			this.registerNewScore_endFunc();
			this.registerNewScore_endFunc = null;
		}
	};
	
	
	//Connect to Online Servers
	this.NEX; this.DS; this.GS; this.RC;
	this.locked = false; this.isOnline = false;
	this.onlineConnect = function(numAttempts, onceConnectedFunc, failedConnectFunc)
	{
		//if (failedConnectFunc) failedConnectFunc(); return false;
		if (!Render.actCanInternet)
		{
			if (failedConnectFunc) failedConnectFunc();
			return false;
		}
		
		if (typeof numAttempts == "undefined") numAttempts = 0;
		if (this.isOnline || this.locked)
		{
			if (this.isOnline)
			{
				if (onceConnectedFunc)
				{
					onceConnectedFunc();
					onceConnectedFunc = null;
				}
			} else if (this.locked) {
				if (failedConnectFunc)
				{
					failedConnectFunc();
					failedConnectFunc = null;
				}
			}
			return false;
		}
		
		this.NEX = window.nwf.nex;
		//this.DS = this.NEX.DataStore.getInstance();
		this.GS = this.NEX.GameServer.getInstance();
		this.RC = this.NEX.RankingClient.getInstance();
		this.locked = true;
		this.isOnline = false;
		
		/*if (!this.GS.isLoggedIn)
		{
			this.GS.addEventListener(nwf.events.GameServerEvent.LOGIN_SUCCESS, onLoginSuccess, this);
			this.GS.addEventListener(nwf.events.GameServerEvent.LOGIN_FAILED, onLoginFailure, this);
			this.GS.login();
		} else {
		   onLoginSuccess();
		}*/
		
		this.GS.addEventListener(nwf.events.GameServerEvent.DISCONNECTED, onDisconnect, this);
		
		// try to log in to the NEX Game Server
		tryLogin();
		
		function tryLogin() {
			log('[tryLogin] Trying to log in...');
			
			if (!Leaderboard.GS.isLoggedIn){
				Leaderboard.GS.addEventListener(nwf.events.GameServerEvent.LOGIN_SUCCESS, onLoginSuccess, this);
				Leaderboard.GS.addEventListener(nwf.events.GameServerEvent.LOGIN_FAILED, onLoginFailure, this);
				Leaderboard.locked = true;
				Leaderboard.GS.login();
			}
			else {
				onLoginSuccess();
			}
		}
		
		/**
		 * Notify the user that the login has completed.
		 * @param {Object} evt 
		 */
		function onLoginSuccess(evt) {
			Leaderboard.GS.removeEventListener(nwf.events.GameServerEvent.LOGIN_SUCCESS, onLoginSuccess, this);
			Leaderboard.GS.removeEventListener(nwf.events.GameServerEvent.LOGIN_FAILED, onLoginFailure, this);
			
			// bind the DataStore object
			/*if (!Leaderboard.DS.isBound) {
				Leaderboard.DS.bind();
			}*/
			// bind the DataStore object
			if (!Leaderboard.RC.isBound) {
				Leaderboard.RC.bind();
			}
			
			log('[onLoginSuccess] Login successful');
			Leaderboard.locked = false;
			Leaderboard.isOnline = true;
			
			if (onceConnectedFunc)
			{
				onceConnectedFunc();
				onceConnectedFunc = null;
			}
		}

		/**
		 * Notify the user that the login has failed.
		 * @param {Object} evt 
		 */
		function onLoginFailure(evt) {
			Leaderboard.GS.removeEventListener(nwf.events.GameServerEvent.LOGIN_SUCCESS, onLoginSuccess, this);
			Leaderboard.GS.removeEventListener(nwf.events.GameServerEvent.LOGIN_FAILED, onLoginFailure, this);
			log('[onLoginFailure] Failed to log in to NEX Game Server');
			Leaderboard.locked = false;
			Leaderboard.isOnline = false;
			
			if (numAttempts > 0)
			{
				setTimeout(function()
				{
					Leaderboard.onlineConnect(numAttempts-1, onceConnectedFunc);
				}, 2500);
			} else {
				if (failedConnectFunc)
				{
					failedConnectFunc();
					failedConnectFunc = null;
				}
			}
		}
		
		function onDisconnect(evt) {
			log('[onDisconnect] NEX Game Server has been disconnected');
			Leaderboard.locked = false;
			Leaderboard.isOnline = false;
		}
		
		function log(msg)
		{
			//console.log(msg);
		}
	};
	
	this.isUploadingScore = false;
	this.uploadScore_Cache = {};
	this.uploadScore = function(score, cat, params, onceUploadedFunc, failedUploadedFunc)
	{
		if (typeof params == "undefined") params = [];
		//Max = 4294967295
		if (score < 0)
		{
			onceUploadedFunc();
			return false;
		}
		if (typeof Leaderboard.myTopScores == "undefined") Leaderboard.myTopScores = {"": -1};
		if (!this.onlineFuncsCallCheck("put", (typeof Leaderboard.myTopScores[Render.act.accountID] != "undefined" ? 1 : 2)))
		{
			failedUploadedFunc();
			return false;
		}
		if (!Render.actIsOnline)
		{
			failedUploadedFunc();
			return false;
		}
		
		if (this.isUploadingScore)
		{
			failedUploadedFunc();
			return false;
		}
		this.isUploadingScore = true;
		
		this.RC.addEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_SUCCESS, onUploadSuccess, this);
		this.RC.addEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_FAILED, onUploadFailure, this);
		
		//( scoreValue, [scoreCategory], [scoreGroup0], [scoreGroup1], [scoreOrderDesc], [deleteOldScore], [scoreParamData], [uniqueID] ) : uint32
		this.onlineFuncsCallLog();
		this.RC.uploadScore(score, cat, 0, 0, true, !true, "");
		this.uploadScore_Cache = {score: score, cat: cat};
		
		
		function onUploadSuccess(evt) {
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_SUCCESS, onUploadSuccess, this);
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_FAILED, onUploadFailure, this);
			
			Leaderboard.isUploadingScore = false;
			Leaderboard.getScoresOnlineLast = {};
			
			if (typeof Leaderboard.myTopScores[Render.act.accountID] == "undefined")
			{
				this.RC.addEventListener(nwf.events.RankingClientEvent.UPLOAD_COMMON_DATA_SUCCESS, onUpload2Success, this);
				this.RC.addEventListener(nwf.events.RankingClientEvent.UPLOAD_COMMON_DATA_FAILED, onUpload2Failure, this);
				
				var data = params.join("/");
				var blob = new Blob(data, {type: 'text/plain'});
				Leaderboard.onlineFuncsCallLog();
				Leaderboard.RC.uploadCommonData(blob);
				
				function onUpload2Success(evt) {
					Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_COMMON_DATA_SUCCESS, onUpload2Success, this);
					Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_COMMON_DATA_FAILED, onUpload2Failure, this);
					
					Leaderboard.myTopScores[Render.act.accountID] = Leaderboard.uploadScore_Cache.score;
					Render.saveData.myTopScores = Leaderboard.myTopScores;
					Render._saveDataUpdate(Render.saveData, true);
					if (onceUploadedFunc)
					{
						onceUploadedFunc();
						onceUploadedFunc = null;
					}
				}
				function onUpload2Failure(evt) {
					Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_COMMON_DATA_SUCCESS, onUpload2Success, this);
					Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_COMMON_DATA_FAILED, onUpload2Failure, this);
					
					if (onceUploadedFunc)
					{
						onceUploadedFunc();
						onceUploadedFunc = null;
					}
				}
			} else {
				Leaderboard.myTopScores[Render.act.accountID] = Leaderboard.uploadScore_Cache.score;
				Render.saveData.myTopScores = Leaderboard.myTopScores;
				Render._saveDataUpdate(Render.saveData, true,
					function()
					{
						if (onceUploadedFunc)
						{
							onceUploadedFunc();
							onceUploadedFunc = null;
						}
					});
			}
		}
		function onUploadFailure(evt) {
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_SUCCESS, onUploadSuccess, this);
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_FAILED, onUploadFailure, this);
			
			Leaderboard.isUploadingScore = false;
			
			if (failedUploadedFunc)
			{
				failedUploadedFunc();
				failedUploadedFunc = null;
			}
		}
	};
	
	//DONT ALLOW CHANGE< MAKE IT CONTIUE TO GET OR FAIL UNTIL DONE
	this.isGettingScores = false; this.getScoresOnlineLast = {}; this.getScoresOnlineMine = null;
	this.getScoresOnline = function(cat, settings, ranksArray, ranksArrayName, onceRetrievedFunc, failedRetrievedFunc)
	{
		if (typeof settings == "undefined") settings = {};
		
		if (this.isGettingScores || !this.onlineFuncsCallCheck() ||
			(this.getScoresOnlineLast[ranksArrayName] != undefined && this.getScoresOnlineLast[ranksArrayName] > Date.now()-3*60*1000))
		{
			failedRetrievedFunc();
			return false;
		}
		this.isGettingScores = true;
		
		this.RC.addEventListener(nwf.events.RankingClientEvent.DOWNLOAD_RANKING_LIST_SUCCESS, onDownloadSuccess, this);
		this.RC.addEventListener(nwf.events.RankingClientEvent.DOWNLOAD_RANKING_LIST_FAILED, onDownloadFailure, this);
		
		var RSP = new nwf.nex.RankingSearchParam();
		RSP.category = cat;
		for(var key in settings)
			RSP[key] = settings[key];
		
		this.onlineFuncsCallLog();
		this.RC.downloadRankingList(RSP);
		
		
		function onDownloadSuccess(evt) {
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.DOWNLOAD_RANKING_LIST_SUCCESS, onDownloadSuccess, this);
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.DOWNLOAD_RANKING_LIST_FAILED, onDownloadFailure, this);
			
			Leaderboard.isGettingScores = false;
			Leaderboard.onlineScores[ranksArrayName] = [];
			Leaderboard.getScoresOnlineLast[Leaderboard.area] = Date.now();
			var ranks = evt.ranks, score=0;
			for(var key in ranks)
			{
				var rank = ranks[key];
				score = Math.floor(rank.score);// / 1000;
				
				//for(var i=0; i<15; i++) {
				var rankData = {};
				rankData.order = rank.order;// +i;
				rankData.score = Math.floor(score);// /(i > 0 ? i : 0.5));
				rankData.name = "";
				rankData.level = "";
				Leaderboard.readRankData(rank, rankData);
				Leaderboard.onlineScores[ranksArrayName].push(rankData);
				//}
			}
			
			if (ranksArrayName == "all")
			{
				Leaderboard.onlineScores["user"] = {};
				Leaderboard.getScoresOnlineMine = setTimeout(function(ranksArrayName)
				{
					if (ranksArrayName != Leaderboard.area) return false;
					var foundMe = false;
					var myAct = nwf.act.NintendoAccountManager.getInstance().getActiveAccount();
					var playerName = myAct.accountID ? myAct.accountID : "Player";
					var scores = Leaderboard.onlineScores[ranksArrayName];
					for(var rank in scores)
					{
						score = scores[rank];
						if (score.name == playerName) foundMe = true;
					}
					if (foundMe) return false;
					
					Leaderboard.getScoresOnline(0, {rankingMode: nwf.nex.RankingMode.USER}, {}, "user",
						function()
						{
							Leaderboard.getScoresDisplay(Leaderboard.onlineScores[Leaderboard.area]);
						},
						function()
						{
							Leaderboard.getScoresDisplay(Leaderboard.onlineScores[Leaderboard.area]);
						});
					
				}, 500, ranksArrayName);
			}
			
			if (onceRetrievedFunc)
			{
				onceRetrievedFunc(Leaderboard.onlineScores);
				onceRetrievedFunc = null;
			}
		}
		function onDownloadFailure(evt) {
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_SUCCESS, onDownloadSuccess, this);
			Leaderboard.RC.removeEventListener(nwf.events.RankingClientEvent.UPLOAD_SCORE_FAILED, onDownloadFailure, this);
			
			Leaderboard.isGettingScores = false;
			Leaderboard.onlineScores[ranksArrayName] = [];
			
			if (failedRetrievedFunc)
			{
				failedRetrievedFunc();
				failedRetrievedFunc = null;
			}
		}
	};
	this.readRankData = function(rank, rankData)
	{
		var reader = new FileReader();
		reader.onloadend = function(evt) {
		   // reader.result contains the contents of blob as a typed array
			Leaderboard._blob = evt;
			var string = new TextDecoder("utf8").decode(evt.target.result);
			if (string != "")
			{
				string = string.split("/");
				rankData.name = string[0];
				if (!rankData.name) rankData.name = "Player";
				
				var tr = $("#highscores_table tbody tr.rank_"+(parseInt(rankData.order)-1));
				if (tr.length)
				{
					var myAct = Render.act, playerName = myAct.accountID ? myAct.accountID : "Player";
					if (playerName == rankData.name) tr.addClass("user");
					tr.find(".name").html(rankData.name);
				}
			}
		};
		reader.readAsArrayBuffer(rank.commonData);
	};
	
	//Log the time instance of this call
	this.onlineFuncsCallLog = function()
	{
		this.onlineFuncsTimes.push(Date.now());
	};
	
	//Make sure this call can happen
	this.onlineFuncsCallCheck = function(type, numAdd)
	{
		if (typeof type == "undefined") type = "";
		if (typeof numAdd == "undefined") numAdd = 1;

		//console.log(type, this.onlineFuncsTimes.length+numAdd, this.onlineFuncsLimitTypes[type]);
		if (this.onlineFuncsTimes.length+numAdd <= this.onlineFuncsLimitTypes[type]) return true;
		//if (this.onlineFuncsTimes.length < this.onlineFuncsLimit) return true;
		
		var dateNow = Date.now();
		var list = [];
		for(var key in this.onlineFuncsTimes)
			if (this.onlineFuncsTimes[key] > dateNow - this.onlineFuncsTimeLimit)
				list.push(this.onlineFuncsTimes[key]);
		this.onlineFuncsTimes = list;
		
		if (this.onlineFuncsTimes.length+numAdd <= this.onlineFuncsLimitTypes[type]) return true;
		//if (this.onlineFuncsTimes.length < this.onlineFuncsLimit) return true;
		return false;
	};
	
	
	
	//Initials
	this.initialsOn = function(block)
	{
		$("#leaderboard_newhighscore .initials").removeClass("on");
		block.addClass("on");
	};
	this.initialsArrow = function(block, dir)
	{
		var leters = " ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.-";
		var leter = block.find(".initial").text();
		var leterAt = leters.indexOf(leter);
		
		leterAt += dir;
		if (leterAt >= leters.length) leterAt = 0;
		else if (leterAt < 0) leterAt = leters.length-1;
		
		leter = leters[leterAt];
		block.find(".initial").text(leter);
	};
	
	
	//Event Triggers
	this.eventTrigger = function(type, e)
	{
		if (!(this.isOpen || this.isOpenNewScore)) return false;
		var popup = $("#leaderboard_newhighscore");
		
		switch(type)
		{
		case "keydown":
		break;
		
		case "keyup":
			switch(e.which)
			{
			//Left
			case 37:
				if (popup.is(":visible"))
				{
					var index = parseInt(popup.find(".initials.on").attr("data-index"));
					index--;
					if (index < 0) index = 0;
					
					Leaderboard.initialsOn(popup.find(".initials[data-index="+index+"]"));
				}
			break;
			
			//Up
			case 38:
				if (popup.is(":visible"))
				{
					var block = popup.find(".initials.on");
					
					Leaderboard.initialsArrow(block, 1);
				}
			break;
			
			//Right
			case 39:
				if (popup.is(":visible"))
				{
					var index = parseInt(popup.find(".initials.on").attr("data-index"));
					index++;
					if (index > 2) index = 2;
					
					Leaderboard.initialsOn(popup.find(".initials[data-index="+index+"]"));
				}
			break;
			
			//Down
			case 40:
				if (popup.is(":visible"))
				{
					var block = popup.find(".initials.on");
					
					Leaderboard.initialsArrow(block, -1);
				}
			break;
			}
		break;
		
		case "held":
		break;
		}
	};
};
var Leaderboard = new Leaderboard();