function MainMenu()
{
	this.isOpen = false;
	
	//Initiate the Main Menu
	this.init = function()
	{
		this.isOpen = true;
		
		var cxt = Game.context;
		cxt.imageSmoothingEnabled = false;
		cxt.font = "14px KenVector Future"; cxt.lineWidth = 10;
		cxt.textBaseline = "top"; cxt.fillStyle = "#FFF";
		
		Game.distance = 0;
		Game.levels.length = 0;
		Game.determineNextLevel("start");
		Game.determineNextLevel("a");
		
		$("#mainmenu").show();
		
		Render.renderHandle = function(renderSpeed){ MainMenu.render(renderSpeed); };
		
		Render.audioStopAll("title");
		Render.audio["title"].play();
	};
	
	//Exit
	this.exit = function()
	{
		this.isOpen = false;
		$("#mainmenu").hide();
	};
	
	//Render
	this.render = function(renderSpeed)
	{
		this.gameAction(renderSpeed);
		
		//this.canvas.width = this.canvas.width+0;
		var cxt = Game.context;
		var scale = Game.scale;
		cxt.font = "14px KenVector Future"; cxt.lineWidth = 10;
		cxt.textBaseline = "top"; cxt.fillStyle = "#FFF";
		
		//Loop through levels
		var levels = Game.levels, level, x, y, i, j, n, m, img, obj;
		//this.tileSize = 128; this.levelWidth = 5; this.levelHeight = 6;
		for(var levelID in levels)
		{
			level = levels[levelID];
			if (level.x >= Game.renderWidth) continue;
			
			if (level.canvas) cxt.drawImage(level.canvas, level.x*scale, Game.yOffset*scale);
		}
	};
	
	//Game Action
	this.gameAction = function(renderSpeed)
	{
		var speed = 10*renderSpeed, now = Date.now();
		
		
		/*---    Movement/Actions    ---*/
		
		//Levels
		var doSaveLevels = false;
		var levels = Game.levels, level, lastX = 0;
		for(var levelID in levels)
		{
			level = levels[levelID];
			
			level.x -= speed;
			if (lastX < level.x+level.w*Game.tileSize) lastX = level.x+level.w*Game.tileSize;
			
			if (level.x + level.w*Game.tileSize < 0) doSaveLevels = true;
		}
		
		
		/*---    Clean Up    ---*/
		if (doSaveLevels)
		{
			var levels2 = [];
			for(var levelID in levels)
			{
				level = levels[levelID];
				if (level.x + level.w*Game.tileSize < 0) continue;
				
				levels2[levels2.length] = level;
			}
			Game.levels = levels2;
		}
		
		//Generate New Level
		if (lastX - Game.renderWidth/2 < Game.renderWidth)
		{
			Game.determineNextLevel();
		}
	};
	
	
	//Start the game
	this.startGame = function()
	{
		MainMenu.exit();
		
		var carType = Game.carSelected.type, carColor = Game.carSelected.color, img;
		var carObj = jQuery.extend(true, {}, Game.cars[carType]);
		img = carType+(carObj.hasColors ? "_"+(carColor ? carColor : "black") : "");
		
		var div;
		$("#mainmenu_game").show()
			.find(".carselect .selected img").attr({src: "media/cars/"+img+".png"}).end()
			.find(".carselect .name").text(carObj.title);
		$("#mainmenu_gamecolor").hide();
		var unlockedCars = [];
		for(var i=0,n=Rewards.myRank; i<n; i++)
			if (Rewards.ranks[i] && Rewards.ranks[i].type == "carselect")
				unlockedCars[unlockedCars.length] = Rewards.ranks[i].value;
		if (unlockedCars.length > 0) $("#mainmenu_game .carselect .arrows").show();
		else $("#mainmenu_game .carselect .arrows").hide();
		
		//Colors
		if (carObj.hasColors)
		{
			$("#mainmenu_gamecolor").show().find(".colors").html("");
			
			var colors = ["black", "blue", "green", "red", "yellow"], color;
			for(var key in colors)
			{
				color = colors[key];
				
				div = $("<div class='color' data-color='"+color+"' style='background:"+color+";'></div>");
				div.click(function()
				{
					var color = $(this).attr("data-color");
					Game.carSelected.color = color;
					
					var carType = Game.carSelected.type, carColor = Game.carSelected.color, img;
					var carObj = Game.cars[carType];
					
					img = carType+(carObj.hasColors ? "_"+(carColor ? carColor : "black") : "");
					$("#mainmenu_game").find(".carselect .selected img").attr({src: "media/cars/"+img+".png"});
				});
				$("#mainmenu_gamecolor .colors").append(div);
			}
		}
		
		//Upgrades
		var upgradeType = Game.carUpgrade, upgradeObj;
		var unlockedUpgrades = [""];
		for(var i=0,n=Rewards.myRank; i<n; i++)
			if (Rewards.ranks[i] && Rewards.ranks[i].type == "upgradeselect")
				if (!(!carObj.rocket.canfire && Game.upgrades[Rewards.ranks[i].value].type == "rocket"))
					unlockedUpgrades[unlockedUpgrades.length] = Rewards.ranks[i].value;
		if (unlockedUpgrades.length > 1)
		{
			upgradeType = Game.carUpgrade;
			if (upgradeType)
			{
				upgradeObj = Game.upgrades[upgradeType];
				img = "media/"+upgradeObj.img+".png";
			} else {
				upgradeObj = {title: "[None]", subtitle: ""};
				img = "";
			}
			$("#mainmenu_gameupgrades").show()
				.find(".upgradeselect .selected img").attr({src: img}).show().end()
				.find(".upgradeselect .name").text(upgradeObj.title).end()
				.find(".upgradeselect .subname").text(upgradeObj.subtitle);
			if (!img) $("#mainmenu_gameupgrades .upgradeselect .selected img").hide();
			
			//Upgrade Slot 2
			var canUpgrade = false;
			for(var myRank=1; myRank<=Rewards.myRank && !canUpgrade; myRank++)
				if (Rewards.ranks[myRank-1].type == "upgradeslot")
					canUpgrade = true;
			if (canUpgrade)
			{
				upgradeType = Game.carUpgrade2;
				if (upgradeType)
				{
					upgradeObj = Game.upgrades[upgradeType];
					img = "media/"+upgradeObj.img+".png";
				} else {
					upgradeObj = {title: "[None]", subtitle: ""};
					img = "";
				}
				$("#mainmenu_gameupgrades").removeClass("oneslot")
					.find(".upgradeselect2").show().end()
					.find(".upgradeselect2 .selected img").attr({src: img}).show().end()
					.find(".upgradeselect2 .name").text(upgradeObj.title).end()
					.find(".upgradeselect2 .subname").text(upgradeObj.subtitle);
				if (!img) $("#mainmenu_gameupgrades .upgradeselect2 .selected img").hide();
			} else {
				$("#mainmenu_gameupgrades").addClass("oneslot").find(".upgradeselect2").hide();
			}
		} else {
			$("#mainmenu_gameupgrades").hide();
		}
		
		
		//Stats
		var upgrades = [Game.carUpgrade, Game.carUpgrade2];
		var upgradeType, upgradeObj;
		for(var key in upgrades)
		{
			upgradeType = upgrades[key];
			if (!upgradeType) continue;
			upgradeObj = Game.upgrades[upgradeType];
			
			switch(upgradeObj.dataType)
			{
			default:
				if (upgradeObj.data.car)
					for(var fieldKey in upgradeObj.data.car)
						carObj[fieldKey] += upgradeObj.data.car[fieldKey];
				if (upgradeObj.data.rocket)
					for(var fieldKey in upgradeObj.data.rocket)
						carObj.rocket[fieldKey] += upgradeObj.data.rocket[fieldKey];
			break;
			
			case "percent":
				if (upgradeObj.data.car)
					for(var fieldKey in upgradeObj.data.car)
						carObj[fieldKey] *= upgradeObj.data.car[fieldKey];
				if (upgradeObj.data.rocket)
					for(var fieldKey in upgradeObj.data.rocket)
						carObj.rocket[fieldKey] *= upgradeObj.data.rocket[fieldKey];
			break;
			}
		}
		var statsData = {
			speed: (carObj.speed)*15,
			fuel: (carObj.fuel)*1,
			firerate: (1/carObj.rocket.firerate)*1500
		};
		var stats = $("#mainmenu_game .stats");
		for(var sub in statsData)
			stats.children(".stat[data-sub='"+sub+"']").find(".barm").width(statsData[sub]);
		if (carObj.rocket.canfire) stats.children(".stat[data-sub='firerate']").show();
		else stats.children(".stat[data-sub='firerate']").hide();
	};
	
	//Slider Actions
	this.startGame_sliderAction = function(type, dir)
	{
		switch(type)
		{
		default: break;
		
		case "carselect":
			var carType = Game.carSelected.type, carIndex = 0;
			var unlockedCars = [];
			for(var i=0,n=Rewards.myRank; i<n; i++)
				if (Rewards.ranks[i] && Rewards.ranks[i].type == "carselect")
					unlockedCars[unlockedCars.length] = Rewards.ranks[i].value;
			
			var cars = [], index = 0;
			for(var car in Game.cars)
			{
				if (!Game.cars[car].unlocked && jQuery.inArray(car, unlockedCars) == -1) continue;
				
				cars[cars.length] = car;
				if (car == carType) carIndex = index;
				index++;
			}
			
			carIndex += dir;
			if (carIndex < 0) carIndex = cars.length-1;
			else if (carIndex >= cars.length) carIndex = 0;
			Game.carSelected.type = cars[carIndex];
			Game.carUpgrade = ""; Game.carUpgrade2 = "";
			
			this.startGame();
		break;
		
		case "upgradeselect":
			//carUpgrade - carObj.rocket.canfire
			var carType = Game.carSelected.type, carObj = Game.cars[carType];
			var unlockedUpgrades = [""];
			for(var i=0,n=Rewards.myRank; i<n; i++)
				if (Rewards.ranks[i] && Rewards.ranks[i].type == "upgradeselect")
					if (!(!carObj.rocket.canfire && Game.upgrades[Rewards.ranks[i].value].type == "rocket"))
						unlockedUpgrades[unlockedUpgrades.length] = Rewards.ranks[i].value;
			
			var upgradeType = Game.carUpgrade, upgradeIndex = -1;
			var upgrades = [""], index = 0;
			for(var upgrade in Game.upgrades)
			{
				if (!Game.upgrades[upgrade].unlocked && jQuery.inArray(upgrade, unlockedUpgrades) == -1) continue;
				if (!carObj.rocket.canfire && Game.upgrades[upgrade].type == "rocket") continue;
				if (upgrade == Game.carUpgrade2) continue;
				
				upgrades[upgrades.length] = upgrade;
				if (upgrade == upgradeType) upgradeIndex = index;
				index++;
			}
			upgradeIndex++;
			
			upgradeIndex += dir;
			if (upgradeIndex < 0) upgradeIndex = upgrades.length-1;
			else if (upgradeIndex >= upgrades.length) upgradeIndex = 0;
			Game.carUpgrade = upgrades[upgradeIndex];
			
			this.startGame();
		break;
		
		case "upgradeselect2":
			//carUpgrade - carObj.rocket.canfire
			var carType = Game.carSelected.type, carObj = Game.cars[carType];
			var unlockedUpgrades = [""];
			for(var i=0,n=Rewards.myRank; i<n; i++)
				if (Rewards.ranks[i] && Rewards.ranks[i].type == "upgradeselect")
					if (!(!carObj.rocket.canfire && Game.upgrades[Rewards.ranks[i].value].type == "rocket"))
						unlockedUpgrades[unlockedUpgrades.length] = Rewards.ranks[i].value;
			
			var upgradeType = Game.carUpgrade2, upgradeIndex = -1;
			var upgrades = [""], index = 0;
			for(var upgrade in Game.upgrades)
			{
				if (!Game.upgrades[upgrade].unlocked && jQuery.inArray(upgrade, unlockedUpgrades) == -1) continue;
				if (!carObj.rocket.canfire && Game.upgrades[upgrade].type == "rocket") continue;
				if (upgrade == Game.carUpgrade) continue;
				
				upgrades[upgrades.length] = upgrade;
				if (upgrade == upgradeType) upgradeIndex = index;
				index++;
			}
			upgradeIndex++;
			
			upgradeIndex += dir;
			if (upgradeIndex < 0) upgradeIndex = upgrades.length-1;
			else if (upgradeIndex >= upgrades.length) upgradeIndex = 0;
			Game.carUpgrade2 = upgrades[upgradeIndex];
			
			this.startGame();
		break;
		}
	};
	
	
	//Select Button Move Index
	this.selectButtonMove = function(popup, dir)
	{
		var buttons = popup.find(".button");
		
		var index = 0, onIndex = 0;
		buttons.each(function()
		{
			if ($(this).hasClass("red")) onIndex = index;
			index++;	
		});
		
		onIndex += dir;
		if (onIndex < 0) onIndex = 0;
		else if (onIndex > buttons.length-1) onIndex = buttons.length-1;
		
		index = 0;
		buttons.removeClass("red").each(function()
		{
			if (index == onIndex) $(this).addClass("red");
			index++;
		});
	};
};
var MainMenu = new MainMenu();