function Render()
{
	this.version = 1.0;
	this.isFullyLoaded = false; this.loadedImages = {total: 0, loaded: 0};
	this.imagesTotal = 0; this.imagesLoaded = 0;
	this.images = {}; this.audio = {};
	
	this.saveData = {}; this.saveDataLoaded = false;
	this.gameIsLoadedHandle = null;
	
	this.renderTime = 0;
	this.renderTimeFPS = [];
	
	this.act; this.actCanMiiverse = false; this.actCanInternet = false;
	this.actCanMiiverseShow = false;
	this.actIsOnline = true;
	
	this.miiverseStamps = ["car", "bike", "speedup", "explosion", "barrel",
	                       "bullet", "cactus", "tree", "rock", "zacicar"];
	
	this.init = function()
	{
		Game.canvas = document.getElementById("canvas");
		Game.context = Game.canvas.getContext("2d");
		Game.canvas.width = 1280;//this.renderWidth;
		Game.canvas.height = 720;//this.renderHeight;
		
		this.gameIsLoadedHandle = setInterval(function()
		{
			if (Render.loadedImages.loaded >= Render.loadedImages.total && Render.saveDataLoaded)
			{
				clearInterval(Render.gameIsLoadedHandle);
				
				Leaderboard.scores = Render.saveData.leaderboard;
				Leaderboard.myTopScores = Render.saveData.myTopScores;
				Rewards.init(Render.saveData.rewards.myRank, Render.saveData.rewards.myDistance);
				
				Render.isFullyLoaded = true;
				$("#splashscreen").hide();
				MainMenu.init();
			}
		}, 150);
		
		//Preload Save Data
		this.preloadSaveData();
		
		//Preload the Images & Audio files
		this.preloadImagesAudio();
		
		//Main Account
		if (typeof nwf != "undefined")
		{
			this.act = nwf.act.NintendoAccountManager.getInstance().getActiveAccount();
			this.actCanMiiverse = this.act.miiverseRestrictionLevel == nwf.act.NintendoAccount.RESTRICTION_NONE;
			this.actCanInternet = this.act.networkCommunicationAllowed;
			
			//Make sure doesn't try to auto-connect
			var net = nwf.net.Network.getInstance();
			net.addEventListener(nwf.events.NetworkEvent.CONNECTED, function()
			{
				Render.actIsOnline = true;
				DialogConnectOnline.connectedSuccess();
			}, this);
			net.addEventListener(nwf.events.NetworkEvent.DISCONNECTED, function()
			{
				Render.actIsOnline = false;
			}, this);
			net.addEventListener(nwf.events.NetworkEvent.FAILED_TO_CONNECT, function()
			{
				Render.actIsOnline = false;
				DialogConnectOnline.connectedFail();
				nwf.net.Network.workOffline();
			}, this);
		}
		
		//Listen for events
		$("body").on("keydown", function(e)
		{
			Game.eventTrigger("keydown", e);
			Leaderboard.eventTrigger("keydown", e);
		}).on("keyup", function(e)
		{
			Game.eventTrigger("keyup", e);
			Leaderboard.eventTrigger("keyup", e);
		});
		InputBank.add({
			id: "abutton",
			type: ["a", "l2", "r2", "l", "r"],
			held: function(clickID, vaultEntry, type, controller)
			{
				if (Game.gameStarted && !Game.gameOver && Game.heldKeys["move"] != 0.00)
					Game.eventTrigger("keydown", {which: 65});
			},
			release: function(clickID, vaultEntry, type, controller)
			{
				if (Game.gameStarted && !Game.gameOver && Game.heldKeys["move"] != 0.00)
					Game.eventTrigger("keyup", {which: 65});
			}
		});
		InputBank.add({
			id: "otherbuttons",
			type: ["b", "x", "y", "start"],
			action: function(clickID, vaultEntry, type, controller)
			{
				var key = 0;
				switch(type)
				{
				case "x": key = 88; break;
				case "y": key = 89; break;
				case "start": key = 13; break;
				}
				if (Game.gameStarted && !Game.gameOver && Game.heldKeys["move"] != 0.00)
					Game.eventTrigger("keydown", {which: key});
			},
			held: function(clickID, vaultEntry, type, controller)
			{
				var key = 0;
				switch(type)
				{
				case "b": key = 66; break;
				}
				if (Game.gameStarted && !Game.gameOver && Game.heldKeys["move"] != 0.00)
					Game.eventTrigger("keydown", {which: key});
			},
			release: function(clickID, vaultEntry, type, controller)
			{
				var key = 0;
				switch(type)
				{
				case "b": key = 66; break;
				case "x": key = 88; break;
				case "y": key = 89; break;
				}
				if (Game.gameStarted && !Game.gameOver && Game.heldKeys["move"] != 0.00)
					Game.eventTrigger("keyup", {which: key});
			}
		});
		InputBank.add({
			id: "move",
			type: ["left", "right"],
			stick: function(clickID, vaultEntry, type, controller, x, y)
			{
				Game.eventTrigger("held2", {x: x, y: y});
			}
		});
		
		
		//Render Loop
		function _loop()
		{
			Render.render();
			
			//return setTimeout(_loop, 16);
			if (window.webkitRequestAnimationFrame != undefined) { window.webkitRequestAnimationFrame(_loop); return false; }
			requestAnimationFrame(_loop);
		};
		_loop();
		
		InputBank.init();
		Leaderboard.init();
	};
	
	this.renderTimeCalled = 0;
	this.renderHandle = null;
	this.render = function()
	{
		var now = Date.now();
		if (this.renderHandle) this.renderHandle(Math.min((now - this.renderTimeCalled)/16, 1.5));
		//if (this.renderTime) console.log(Date.now() - now);
		
		if (this.renderTime && this.renderTimeCalled != 0 && Game.context)
		{
			var ms = Date.now() - this.renderTimeCalled;
			this.renderTimeFPS.push(ms);
			if (this.renderTimeFPS.length > 100) this.renderTimeFPS.shift();
			var avg = 0; for(var key in this.renderTimeFPS) avg += this.renderTimeFPS[key];
			avg /= this.renderTimeFPS.length;
			
			var cxt = Game.context;
			cxt.lineWidth = 2; cxt.font = "64px KenVector Future"; cxt.fillStyle = "#000";
			cxt.textBaseline = "bottom"; cxt.textAlign = "right";
			
			cxt.fillText(avg.toFixed(0), Game.renderWidth-5, Game.renderHeight-5);
		}
		this.renderTimeCalled = now;
	};
	
	
	
	//Number Format
	this.numberFormat = function(number, format)
	{
		if (typeof format == "undefined") format = "long";
		
		//return (number+"").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
		if ((number < 0 ? -number : number) < 1000) return number;
		var isNeg = number < 0, after = "";
		number = number < 0 ? -number : number;
		
		switch(format)
		{
		default:
			number = number.toString();
		break;
		
		case "short":
			if (number >= 1000000000000)
			{
				number = (Math.floor(number / 100000000000)/10).toString();
				after = "T";
			} else if (number >= 1000000000) {
				number = (~~(number / 100000000)/10).toString();
				after = "B";
			} else if (number >= 1000000) {
				number = (~~(number / 100000)/10).toString();
				after = "M";
			} else {
				number = number.toString();
			}
		break;
		
		case "short2":
			if (number >= 1000000000000)
			{
				number = (Math.floor(number / 100000000000)/10).toString();
				after = "T";
			} else if (number >= 1000000000) {
				number = (~~(number / 100000000)/10).toString();
				after = "B";
			} else if (number >= 1000000) {
				number = (~~(number / 100000)/10).toString();
				after = "M";
			} else if (number >= 100000) {
				number = (~~(number / 1000)).toString();
				after = "K";
			} else {
				number = number.toString();
			}
		break;
		}
		
		var rtr = "", i=number.length-1, c=0;
		var hasDecimal = (number.match(/\./) != null), decimalFound = false;
		
		do
		{
			rtr = number[i]+rtr;
			
			if (!hasDecimal || decimalFound) c++;
			if (c > 0 && c % 3 == 0) rtr = ","+rtr;
			if (number[i] == ".") decimalFound = true;
		} while(i--);
		if (rtr.substr(0, 1) == ",")
			rtr = rtr.substr(1, rtr.length-1);
		number = null;
		
		return (isNeg ? "-" : "")+rtr+after;
	};
	
	//Return the angle between two points
	this.piToA = (Math.PI / 180);
	this.piToR = (180 / Math.PI);
	this.determineAngle = function(x1, y1, x2, y2)
	{
		var angle = Math.atan((y2-y1) / (x2-x1)) * this.piToR;

		//Top Right
		if (x1 > x2 && y1 < y2) angle -= 90;
		//Bottom Right
		else if (x1 > x2 && y1 > y2) angle -= 90;
		//Bottom Left
		else if (x1 < x2 && y1 > y2) angle += 90;
		//Top Left
		else if (x1 < x2 && y1 < y2) angle += 90;
		
		//Top Center
		else if (Math.abs(x1 - x2) <= 1 && y1 < y2) angle = 180;
		//Bottom Center
		else if (Math.abs(x1 - x2) <= 1 && y1 > y2) angle = 0;
		//Left Middle
		else if (Math.abs(y1 - y2) <= 1 && x1 < x2) angle = 90;
		//Right Middle
		else if (Math.abs(y1 - y2) <= 1 && x1 > x2) angle = 270;
		
		return angle;
	};
	
	//Return new Points given origin, distance and degree
	this.determineNewPoints = function(x, y, distance, degree)
	{
		while(degree < 0) degree += 360; degree = degree % 360;
		var xSide, ySide;
		var angleA = degree * this.piToA;
		xSide = (distance*Math.sin(angleA)); xSide = xSide < 0 ? -xSide : xSide;
		ySide = (distance*Math.cos(angleA)); ySide = ySide < 0 ? -ySide : ySide;
		if (degree >= 0 && degree < 90) { ySide *= -1; }
		else if (degree < 180) {}
		else if (degree < 270) { xSide *= -1; }
		else if (degree < 360 || degree < 0) { xSide *= -1; ySide *= -1; }
		
		return {x: x+xSide, y: y+ySide};
	};
	
	//Rotate given points around origin
	this.rotatePoints = function(pointX, pointY, originX, originY, angle2)
	{
	    angle2 = angle2 * Math.PI / 180.0;
	    return {
	        x: Math.cos(angle2) * (pointX-originX) - Math.sin(angle2) * (pointY-originY) + originX,
	        y: Math.sin(angle2) * (pointX-originX) + Math.cos(angle2) * (pointY-originY) + originY
	    };
	}
	
	//Is this Point in the given Polygon?
	this.pointInPolygon = function(x, y, poly)
	{
		if (!poly || poly.length == 0) return false;
		
		var pt = {x:x, y:y};
		for(var c = false, i = -1, l = poly.length, j = l - 1; ++i < l; j = i)
			((poly[i].y <= pt.y && pt.y < poly[j].y) || (poly[j].y <= pt.y && pt.y < poly[i].y))
			&& (pt.x < (poly[j].x - poly[i].x) * (pt.y - poly[i].y) / (poly[j].y - poly[i].y) + poly[i].x)
			&& (c = !c);
		return c;
	};
	
	//Determine where these 2 lines intercept, if at all
	this.doesInterceptLine = function(line1StartX, line1StartY, line1EndX, line1EndY, line2StartX, line2StartY, line2EndX, line2EndY)
	{
	    // if the lines intersect, the result contains the x and y of the intersection (treating the lines as infinite) and booleans for whether line segment 1 or line segment 2 contain the point
	    var denominator, a, b, numerator1, numerator2, result = {
	        x: null,
	        y: null,
	        onLine1: false,
	        onLine2: false
	    };
	    denominator = ((line2EndY - line2StartY) * (line1EndX - line1StartX)) - ((line2EndX - line2StartX) * (line1EndY - line1StartY));
	    if (denominator == 0) {
	        return false;
	    }
	    a = line1StartY - line2StartY;
	    b = line1StartX - line2StartX;
	    numerator1 = ((line2EndX - line2StartX) * a) - ((line2EndY - line2StartY) * b);
	    numerator2 = ((line1EndX - line1StartX) * a) - ((line1EndY - line1StartY) * b);
	    a = numerator1 / denominator;
	    b = numerator2 / denominator;

	    // if we cast these lines infinitely in both directions, they intersect here:
	    result.x = line1StartX + (a * (line1EndX - line1StartX));
	    result.y = line1StartY + (a * (line1EndY - line1StartY));
	    /*
	        // it is worth noting that this should be the same as:
	        x = line2StartX + (b * (line2EndX - line2StartX));
	        y = line2StartX + (b * (line2EndY - line2StartY));
	        */
	    // if line1 is a segment and line2 is infinite, they intersect if:
	    if (a > 0 && a < 1) {
	        result.onLine1 = true;
	    }
	    // if line2 is a segment and line1 is infinite, they intersect if:
	    if (b > 0 && b < 1) {
	        result.onLine2 = true;
	    }
	    // if line1 and line2 are segments, they intersect if both of the above are true
	    return result.onLine1 && result.onLine2 ? result : false;
	    
	};
	
	
	//Splits the text and returns it in an array
	this.splitText = function(ctx, text, width)
	{
		var rtr = [];
		
		text = text.split("\n");
		var line, words, word, x, w;
		for(var key in text)
		{
			line = text[key];
			if (ctx.measureText(line).width <= width) rtr.push(line);
			else {
				x = 0;
				words = line.split(" ");
				line = "";
				for(var key2 in words)
				{
					word = words[key2];
					if (word == "") continue;
					word = (line ? " " : "")+word;
					
					w = ctx.measureText(word).width;
					if (x + w > width)
					{
						rtr.push(line);
						x = 0;
						line = "";
						word = words[key2];
					}
					
					x += w;
					line += word;
				}
				if (line != "") rtr.push(line);
			}
		}
		
		return rtr;
	};
	
	
	//Stop All Audio from playing
	this.audioStopAll = function(ignoreID)
	{
		for(var _id in this.audio)
		{
			if (ignoreID && ignoreID == _id) continue;
			
			this.audio[_id].pause();
			this.audio[_id].currentTime = 0;
		}
	};
	
	//Preload the Save Data
	this.preloadSaveData = function()
	{
		if (!FileIO.fileExists("save.txt"))
		{
			this._saveDataUpdate();
		} else {
			FileIO.readFile("save.txt", function(data)
			{
				Render._saveDataUpdate(data);
			}, function()
			{
				Render._saveDataUpdate(undefined, false);
			});
		}
	};
	this._saveDataUpdate_endFunc = null;
	this._saveDataUpdate = function(data, doSaveManual, endFunc)
	{
		if (doSaveManual == undefined) doSaveManual = false;
		this._saveDataUpdate_endFunc = endFunc;
		var doSave = true;
		
		//Create
		if (data == undefined || !data || !data.version)
		{
			data = {
				version: this.version,
				leaderboard: Leaderboard.scores,
				myTopScores: {"": -1},
				rewards: {myRank: 0, myDistance: 0}
			};
			this.saveData = data;
		} else {
			data.version = parseFloat(data.version);
			data.rewards.myRank = parseInt(data.rewards.myRank);
			data.rewards.myDistance = parseInt(data.rewards.myDistance);
			
			this.saveData = data;
			doSave = false;
		}
		
		//Save the File
		if (doSave || doSaveManual)
		{
			FileIO.saveFile("save.txt", data, function()
			{
				Render.saveDataLoaded = true;
				if (Render._saveDataUpdate_endFunc) Render._saveDataUpdate_endFunc();
				Render._saveDataUpdate_endFunc = null;
			}, function()
			{
				Render.saveDataLoaded = true;
				if (Render._saveDataUpdate_endFunc) Render._saveDataUpdate_endFunc();
				Render._saveDataUpdate_endFunc = null;
			});
		} else {
			this.saveDataLoaded = true;
		}
	};
	
	
	//Preload Images/Audio
	this.preloadImagesAudio = function()
	{
		//Images
		var images = {"grass": "media/tiles/grass.png"};
		images["water"] = "media/tiles/water.png";
		images["dirt"] = "media/tiles/dirt.png";
		images["dark"] = "media/tiles/dark.png";
		
		var types = {"t": "09", "tr": "02", "r": "03", "br": "07", "b": "13", "bl": "06", "l": "05", "tl": "01"};
		types["tl2"]=1;types["tr2"]=1;types["bl2"]=1;types["br2"]=1;
		for(var type in types)
		{
			images["water_"+type] = "media/tiles/water_"+type+".png";
			images["dirt_"+type] = "media/tiles/dirt_"+type+".png";
			images["dark_"+type] = "media/tiles/dark_"+type+".png";
		}

		images["road"] = "media/tiles/road_asphalt22.png";
		images["road1"] = "media/tiles/road_asphalt04.png";
		images["road2"] = "media/tiles/road_asphalt40.png";
		
		images["road_hor"] = "media/tiles/road_asphalt02.png";
		images["road_vert"] = "media/tiles/road_asphalt01.png";
		images["road_corner_tl"] = "media/tiles/road_asphalt03.png";
		images["road_corner_tr"] = "media/tiles/road_asphalt05.png";
		images["road_corner_bl"] = "media/tiles/road_asphalt39.png";
		images["road_corner_br"] = "media/tiles/road_asphalt41.png";
		
		images["road1_tolower1"] = "media/tiles/road_asphalt17.png";
		images["road1_tolower2"] = "media/tiles/road_asphalt18.png";
		images["road1_tolower3"] = "media/tiles/road_asphalt36.png";
		images["road2_tolower1"] = "media/tiles/road_asphalt35.png";
		images["road2_tolower2"] = "media/tiles/road_asphalt53.png";
		images["road2_tolower3"] = "media/tiles/road_asphalt54.png";
		
		images["road1_toupper1"] = "media/tiles/road_asphalt33.png";
		images["road1_toupper2"] = "media/tiles/road_asphalt15.png";
		images["road1_toupper3"] = "media/tiles/road_asphalt16.png";
		images["road2_toupper1"] = "media/tiles/road_asphalt51.png";
		images["road2_toupper2"] = "media/tiles/road_asphalt52.png";
		images["road2_toupper3"] = "media/tiles/road_asphalt34.png";
		
		images["obj_barrier"] = "media/objects/barrier_white.png";
		images["obj_barrier_red"] = "media/objects/barrier_red.png";
		for(var i=1; i<=3; i++)
		{
			images["obj_rock"+i] = "media/objects/rock"+i+".png";
		}
		images["obj_oil"] = "media/objects/oil.png";
		images["obj_tree"] = "media/objects/tree_small.png";
		images["obj_tree2"] = "media/objects/tree_red.png";
		images["obj_tribune"] = "media/objects/tribune_full.png";
		var colors = ["blue", "red"], color;
		for(var key in colors)
		{
			color = colors[key];
			
			images["obj_barrel_"+color] = "media/objects/barrel_"+color+".png";
			images["obj_barrel_"+color+"_down"] = "media/objects/barrel_"+color+"_down.png";
		}
		images["obj_cactus"] = "media/objects/Cactus.png";
		images["obj_rocketlauncher"] = "media/objects/RocketLauncher.png";
		/*this.images["obj_coin_bronze"] = new Image();
		images["obj_coin_bronze"] = "media/objects/coinBronze.png";
		this.images["obj_coin_silver"] = new Image();
		images["obj_coin_silver"] = "media/objects/coinSilver.png";
		this.images["obj_coin_gold"] = new Image();
		images["obj_coin_gold"] = "media/objects/coinGold.png";*/
		
		var colors = ["black", "blue", "green", "red", "yellow"], color;
		for(var key in colors)
		{
			color = colors[key];
			
			images["car_"+color] = "media/cars/car_"+color+".png";
			images["bike_"+color] = "media/cars/bike_"+color+".png";
		}
		images["policecar1"] = "media/cars/policecar.png";
		images["policecar2"] = "media/cars/policecar2.png";
		images["ZaciCar"] = "media/cars/ZaciCar.png";
		images["etc_skidmark"] = "media/etc/skidmark_short_1.png";
		
		var colors = ["black", "blue", "green", "red", "yellow", "silver"], color;
		for(var key in colors)
		{
			color = colors[key];
			
			images["etc_rocket_"+color] = "media/etc/bullet"+color.substr(0, 1).toUpperCase()+color.substr(1)+"_outline.png";
		}
		for(var i=0; i<=8; i++)
		{
			images["etc_explode_"+i] = "media/etc/regularExplosion0"+i+".png";
		}

		var colors = ["blue", "green", "red", "yellow", "white", "shadow"], color;
		for(var key in colors)
		{
			color = colors[key];
			
			var types = {};
			types["barLeft_"+color] = "barHorizontal_"+color+"_left";
			types["barMiddle_"+color] = "barHorizontal_"+color+"_mid";
			types["barRight_"+color] = "barHorizontal_"+color+"_right";
			for(var type in types)
			{
				images["ui_"+type] = "media/ui/"+types[type]+".png";
			}
		}
		
		var dirs = ["up", "right", "down", "left"], dir;
		for(var key in dirs)
		{
			dir = dirs[key];
			
			images["road_arrow_"+dir] = "media/etc/road_arrow_"+dir+".png";
		}
		
		images["etc_question"] = "media/icons/question.png";
		images["etc_meter_bg1"] = "media/etc/MeterBack.png";
		images["etc_meter_bg2"] = "media/etc/MeterFront.png";
		images["etc_meter"] = "media/etc/MeterArrow.png";
		
		//Miiverse
		for(var key in this.miiverseStamps)
			images["stamp_"+this.miiverseStamps[key]] = "media/miiverse/"+this.miiverseStamps[key]+".png";
		
		
		for(var _id in images)
		{
			this.loadedImages.total++;
			this.images[_id] = new Image();
			this.images[_id].onload = function()
			{
				Render.loadedImages.loaded++;
			};
			this.images[_id].src = images[_id];
		}
		
		
		//Audio
		var list = {pickup: {src: "pickup5", volume: 0.5}}, aud;
		list.title = {src: "Title", volume: 1.0, loop: true, auto: "auto", autoplay: true};
		list.bg1 = {src: "HotRod1", volume: 1.0, loop: true, auto: "auto", autoplay: false};
		list.bg2 = {src: "HotRod2", volume: 1.0, loop: true, auto: "auto", autoplay: false};
		list.bg3 = {src: "HotRod3", volume: 1.0, loop: true, auto: "auto", autoplay: false};
		list.explosion1 = {src: "Explosion", volume: 1}; list.explosion2 = {src: "Explosion", volume: 1};
		list.getItem = {src: "GetCan", volume: 1}; list.lowGas = {src: "LowGas", volume: 0.5, loop: true};
		list.oil = {src: "OilSlick", volume: 0.7}; list.rocket = {src: "Rocket", volume: 1};
		list.success = {src: "Success", volume: 1}; list.gameover = {src: "GameOver", volume: 1};
		list.sirens = {src: "PoliceSiren", volume: 1, loop: true}; list.honk = {src: "CarHorn", volume: 1};
		for(var _id in list)
		{
			aud = list[_id];
			if (!aud.src) aud = {src: aud};
			aud.src = "audio/"+aud.src+".ogg";
			
			var audio = new Audio();
			for(var key in aud) audio[key] = aud[key];
			this.audio[_id] = audio;
		}
	};
};
var Render = new Render();
function degs_to_rads (degs) { return degs / Render.piToR; }
function rads_to_degs (rads) { return rads * Render.piToR; }


//Dialog popup to connect online
function DialogConnectOnline()
{
	this.containerBG = null;
	this.container0 = null; this.container = null;
	this.successFunc = null;
	
	this.init = function(successFunc)
	{
		if (typeof successFunc == "undefined") successFunc = null;
		this.successFunc = successFunc;
		
		this.open();
	};
	
	this.open = function()
	{
		this.close();
		
		this.containerBG = $("<div style='position:absolute;left:0px;top:0px;width:100%;height:100%;z-index:1000000;background:#000;opacity:0.75;' />");
		this.container0 = $("<div style='position:absolute;left:50%;top:50%;width:600px;height:300px;margin-left:-300px;margin-top:-150px;z-index:1000001;background:URL(media/etc/popup.jpg);background-size:100% 100%;' />");
		this.container0.append("<div style='position:absolute;left:10px;top:10px;width:"+(this.container0.width()-20)+"px;height:"+(this.container0.height()-20)+"px;background:#000;opacity:0.88;' />");
		this.container = $("<div style='position:absolute;left:50%;top:50%;width:550px;height:250px;margin-left:-275px;margin-top:-125px;z-index:1000002;color:#FFF;' />");
		
		var w = 100, h = 26;
		var img_off = $("<img src='media/etc/button_grey.jpg' />");
		img_off.addClass("img_off").css({
			width: w+"px",
			height: h+"px",
			display: "none"
		});
		var img_on = $("<img src='media/etc/button2.jpg' />");
		img_on.addClass("img_on").css({
			width: w+"px",
			height: h+"px"
		});
		
		
		//Main
		var tab = $("<div class='tabs' tab='main' />");
		this.container.append(tab);
		var div = $("<div class='title' style='margin-bottom:35px;margin-top:-5px;font-size:36px;text-align:center;'>Connect Online?</div>");
		tab.append(div);
		
		var div = $("<div class='content' style='padding:0 10px;font-size:18px;'></div>");
		div.html("You are currently offline. Would you like to connect online?");
		tab.append(div);
		
		img_on = img_on.clone();
		img_off = img_off.clone();
		div = $("<div />");
		div.css({
			position: "absolute",
			left: "0px",
			bottom: "0px",
			width: w+"px",
			height: h+"px",
			"font-size": "16px",
			border: "1px solid #666",
			"text-align": "center"
		}).append(img_off).append(img_on)
		  .append("<div style='position:absolute;left:0px;top:2px;width:"+w+"px;'>Cancel</div>").click(function()
		{
			DialogConnectOnline.close();
		});
		tab.append(div);
		
		img_on = img_on.clone();
		img_off = img_off.clone();
		div = $("<div />");
		div.css({
			position: "absolute",
			right: "0px",
			bottom: "0px",
			width: w+"px",
			height: h+"px",
			"font-size": "16px",
			border: "1px solid #666",
			"text-align": "center"
		}).append(img_off).append(img_on)
		  .append("<div style='position:absolute;left:0px;top:2px;width:"+w+"px;'>Connect</div>").click(function()
		{
			DialogConnectOnline.connect();
		});
		tab.append(div);
		
		
		//Connecting
		var tab = $("<div class='tabs' tab='connecting' style='display:none;' />");
		this.container.append(tab);
		var div = $("<div class='title' style='margin-bottom:35px;margin-top:-5px;font-size:36px;text-align:center;'>Connecting...</div>");
		tab.append(div);
		
		var div = $("<div class='content' style='padding:0 10px;font-size:18px;'></div>");
		div.html("Attempting to connect online.");
		tab.append(div);
		
		
		//Failed
		var tab = $("<div class='tabs' tab='failed' style='display:none;' />");
		this.container.append(tab);
		var div = $("<div class='title' style='margin-bottom:35px;margin-top:-5px;font-size:36px;text-align:center;'>Could Not Connect Online</div>");
		tab.append(div);
		
		var div = $("<div class='content' style='padding:0 10px;font-size:18px;'></div>");
		div.html("Could not connect online.");
		tab.append(div);
		
		img_on = img_on.clone();
		img_off = img_off.clone();
		div = $("<div />");
		div.css({
			position: "absolute",
			left: "0px",
			bottom: "0px",
			width: w+"px",
			height: h+"px",
			"font-size": "16px",
			border: "1px solid #666",
			"text-align": "center"
		}).append(img_off).append(img_on)
		  .append("<div style='position:absolute;left:0px;top:2px;width:"+w+"px;'>Cancel</div>").click(function()
		{
			DialogConnectOnline.close();
		});
		tab.append(div);
		
		img_on = img_on.clone();
		img_off = img_off.clone();
		div = $("<div />");
		div.css({
			position: "absolute",
			right: "0px",
			bottom: "0px",
			width: w+"px",
			height: h+"px",
			"font-size": "16px",
			border: "1px solid #666",
			"text-align": "center"
		}).append(img_off).append(img_on)
		  .append("<div style='position:absolute;left:0px;top:2px;width:"+w+"px;'>Connect</div>").click(function()
		{
			DialogConnectOnline.connect();
		});
		tab.append(div);
		
		
		$("#view_gp0").append(this.containerBG);
		$("#view_gp0").append(this.container0);
		$("#view_gp0").append(this.container);
	};
	
	this.close = function()
	{
		if (!this.container) return false;
		
		this.containerBG.remove();
		this.container0.remove();
		this.container.remove();
		this.container0 = null; this.container = null;
		this.successFunc = null;
	};
	
	this.switchTab = function(tab)
	{
		this.container.find(".tabs").hide();
		this.container.find(".tabs[tab='"+tab+"']").show();
	};
	
	this.connectedSuccess = function()
	{
		if (!this.container) return false;
		
		if (this.successFunc) this.successFunc();
		this.close();
	};
	
	this.connectedFail = function()
	{
		if (!this.container) return false;
		
		this.switchTab("failed");
	};
	
	this.connect = function()
	{
		this.switchTab("connecting");
		
		if (!nwf.net.Network.isConnected())
			nwf.net.Network.reconnect();
		else
			this.connectedSuccess();
	};
};
var DialogConnectOnline = new DialogConnectOnline();